/**************************
	This file is copyrighted, but license is hereby granted for personal,
	academic, and non-profit use.
	Commercial users should contact Xin Zhou xzhou82@gmail.com for permission.
 **************************/

var page_config={
//ghm_lineplot:true,
app_splinter:true,
app_bbjconfig:true,
cp_oneshot:{htext:washUtag,
	hpadding:'2px 10px',
	hbutt1:{text:'Blog',
		call:go2blog,
		fg:'white',
		bg:'rgb(255,95,0)',
		}
	},
cp_session:{htext:'Sessions & URLs',
	hbutt1:{text:'&#10005;',call:toggle12}
	},
cp_bev:{htext:'Genome snapshot',
	hbutt1:{text:'&#10005;',call:toggle18}
	},
cp_hmtk:{htext:'Experimental assay tracks',
	hbutt1:{text:'&#10005;',call:toggle1},
	hbutt2:{text:'Remove all',
		call:removeallnativehmtk,
		bg:'rgba(255,0,0,0.7)',
		fg:'white'},
	},
cp_custtk:{htext:'Custom tracks',
	hbutt1:{text:'&#10005;',call:toggle7},
	hbutt2:{text:'Go back',
		call:custtkpanel_back2control,
		fg:'white',
		bg:'#545454'},
	},
cp_svg:{htext:'Screen shot',
	hbutt1:{text:'&#10005;',call:svgpanelhide}
	},
cp_gsv:{htext:'Gene set view',
	hbutt1:{text:'&#10005;',call:toggle10},
	hbutt2:{text:'Turn off',
		call:gsv_turnoff,
		bg:'red',
		fg:'white'},
	},
cp_scatter:{htext:'Scatter plot',
	hbutt1:{text:'&#10005;',call:toggle19},
	hbutt2:{text:'Go back',
		call:scatterplot_goback,
		fg:'white',
		bg:'#545454'},
	},
cp_circlet:{htext:'Circlet plot',
	hbutt1:{text:'&#10005;',call:toggle11},
	hbutt2:{},
	},
cp_geneplot:{htext:'Gene plot',
	hbutt1:{text:'&#10005;',call:toggle4},
	hbutt2:{text:'Go back',
		call:gp_back2control,
		fg:'white',
		bg:'#545454'},
	},
gsselect:true,
};


var browser=null; // the "main panel" browser object, as a global variable

var msgconsole; // message console (but not text area anymore)
var floatingtoolbox;

var appbutt;
var dblst;


/* key: gf name
val: {}
  label: 'print name'
  parent: might be undefined, use 'parent' in decorInfo to check
  grp: group id (-1 for custom track)
  ft:
  hasStruct: 0/1
  queryUrl: directly append gene name after it
  mode: M_mode
  tksentry: used as a hook to this track's <td> element in track selection panel

serves as registry for all decor tracks (bigbed and bigwig)
when a custom bigbed is uploaded, it will be in there
even if the track is closed, it shall not be removed
only if it is explicitly removed by user, shall its record be removed from here
 */


var stickynote = {'number':0};


/***  flags   ***/
var helpmsgshowing = false;
var sortTrackIdx = 0;
var currentPathway; // kegg pathway ID currently been displayed
var mdnotooltip = false; // don't pop up tooltip when dragging metadata color block

var urlparamhelp='<a href=http://washugb.blogspot.com/2012/05/v2-code-release-url-parsing-and.html target=_blank>help&#8599;</a>';



function sumHmtkHeight() {
/* return variable argument
if no argument, will return sum of height for all tracks
else, the argument should be index of a track,
and sum of height for tracks before this one will be given
*/
	var stop;
	if(arguments[0] == undefined)
		stop = browser.gmlst.length;
	else
		stop = arguments[0];
	var h = 0;
	for(var i=0; i<stop; i++) {
		h+=browser.gmlst[i].hmC.height;
	}
	return h;
}
function sumTkheight_nonehmtk() {
/* all decors in main panel, with htest and pwc */
    return document.getElementById('tgt_decorCanvas').clientHeight +
	(pwc.inuse ? pwc.canvas.height : 0) +
	(htest.inuse ? htest.canvas.height : 0);
}





/* age-old, generic operations on DOM elements */
function checkChildRadio(event) { // not used?
    event.target.childNodes[0].checked = true;
}
function copylst_childnodes(domobj) {
    var lst = [];
    for(var i=0; i<domobj.childNodes.length; i++)
        lst.push(domobj.childNodes[i]);
    return lst;
}
function getClass_by_radioName(what) {
    var lst = document.getElementsByName(what);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].checked) return lst[i].className;
    }
    fatalError("None of the options were checked for radio button "+what);
}


/***************************
  small targeted functions 
 ***************************/

function toggleNextSibling(event) {
    var bait=event.target.nextSibling;
    bait.style.display= bait.style.display=='none' ? 'block' : 'none';
}
function toggleNextSibling2(event) {
    var bait=event.target.nextSibling.firstChild;
    bait.style.display= bait.style.display=='none' ? 'block' : 'none';
}
function toggle3(event)
{
// show/hide species menu by clicking on <td> on banner
if(event.target.id=='genomeinfobutt') return;
var holder = document.getElementById('bait3');
holder.style.display = 'block';
var pos = absolutePosition(document.getElementById('genomelogoartholder'));
holder.style.left = pos[0];
document.body.addEventListener('mousedown', toggle3_2, false);
}
function toggle3_2() {document.getElementById('bait3').style.display='none';}
function toggle5() {
// use server metadata to annotate custom bigwig
    var bait = document.getElementById("bait5");
    var hook = document.getElementById("hook5");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.innerHTML = "&uarr; hide";
    } else {
        bait.style.display = "none";
	hook.innerHTML = "&darr; use metadata vocabulary provided here";
    }
}
function toggle16() {
    var bait = document.getElementById("bait16");
    if(bait.style.display == "none") {
        bait.style.display = "table";
    } else {
        bait.style.display = "none";
    }
}
function toggle17(event) {
// tabpage in bev genome panel
    var w = event.target.getAttribute('which');
	var old=document.getElementById('tabpage_bevg_tab'+w).className;
	document.getElementById('tabpage_bevg_content1').style.display='none';
	document.getElementById('tabpage_bevg_content2').style.display='none';
	document.getElementById('tabpage_bevg_content3').style.display='none';
	document.getElementById('tabpage_bevg_tab1').className='tabpageOff';
	document.getElementById('tabpage_bevg_tab2').className='tabpageOff';
	document.getElementById('tabpage_bevg_tab3').className='tabpageOff';
	if(old=='tabpageOff') {
		document.getElementById('tabpage_bevg_tab'+w).className='tabpageOn';
		document.getElementById('tabpage_bevg_content'+w).style.display='block';
	}
}
function toggle21(event) {
    var butt = event.target;
    var ul = document.getElementById("geneplothelpmsg");
    if(ul.style.display == "none") {
        butt.innerHTML = "&#10005;";
	ul.style.display = "block";
    } else {
        butt.innerHTML = "having trouble?";
	ul.style.display = "none";
    }
}
function toggle23(event) {
    var d = document.getElementById("zerosdgeneholder");
    if(d.style.display == 'none') {
        event.target.innerHTML = "hide";
	d.style.display = "block";
    } else {
        event.target.innerHTML = "show";
	d.style.display = "none";
    }
}
function toggle24(event) {
    var s1 = document.getElementById("geneplot_s4_h_span");
    var s2 = document.getElementById("geneplot_s4_k_span");
    if(event.target.selectedIndex == 0) {
        s1.style.display = 'inline'
	s2.style.display = 'none'
    } else {
        s1.style.display = 'none'
	s2.style.display = 'inline'
    }
}
function toggle25()
{
// bigbed generator
var hook = document.getElementById('hook25');
var bait = document.getElementById('bait25');
if(bait.style.display == 'none') {
	cloakPage();
	hook.style.display = 'none';
	panelFadein(bait, 100+document.body.scrollLeft, 100+document.body.scrollTop);
} else {
	hook.style.display = 'inline-block';
	pagecloak.style.display = "none";
	panelFadeout(bait);
}
}
function toggle27() {
// show/hide message console
    var hook = document.getElementById('hook27');
    var bait = document.getElementById('bait27');
    if(bait.style.display == 'none') {
        bait.style.display = 'block';
	hook.style.display = 'none';
        msgconsole.scrollTop = 9999; // dummy
    } else {
        bait.style.display = 'none';
	hook.style.display = 'inline-block';
    }
}
function toggle28(event) {
// called by clicking the checkbox controling ideogram display
    var bait = event.target.nextSibling;
    if(event.target.selectedIndex == 0) {
        bait.style.display = "inline";
	for(var cn in bev.scfd.hash)
	    document.getElementById("bevideogram_"+cn).style.display = "block";
    } else {
        bait.style.display = "none";
	for(var cn in bev.scfd.hash)
	    document.getElementById("bevideogram_"+cn).style.display = "none";
    }
}
function toggle31(event) {
/* push button of scaffold sequences to mark for removal
in case of a to-be-added one, simply remove it
need to tell which scaffold holder is using
*/
    var tr = event.target.parentNode.parentNode;
    var holderid = parseInt(tr.parentNode.parentNode.getAttribute('holderid'));
    if(holderid!=1 && holderid!=2)
        fatalError('toggle31: unknown holderid');

    if(tr.marked) {
        tr.style.backgroundColor = 'white';
	event.target.innerHTML = '&#10005;';
	event.target.title = 'mark for removal';
	tr.marked = false;
    } else {
        if(holderid == 1) {
	    if(tr.seq in scaffold.toadd) {
	        // this seq is pending for adding, just remove it
		scaffold.cpholder.firstChild.removeChild(tr);
		delete scaffold.seq2tr[tr.seq];
		delete scaffold.toadd[tr.seq];
		return;
	    }
	} else {
	    if(tr.seq in bev.scfd.toadd) {
		bev.scfd.holder.firstChild.removeChild(tr);
		delete bev.scfd.seq2tr[tr.seq];
		delete bev.scfd.toadd[tr.seq];
		return;
	    }
	}
        tr.style.backgroundColor = '#e0e0e0';
	event.target.innerHTML = '&#10004;';
	event.target.title = 'unmark';
	tr.marked = true;
    }
    if(holderid == 1) {
	scaffold.updatebutt.style.display = 'inline';
	scaffold.updatebutt.style.backgroundColor = '#e0e0e0';
	document.getElementById('scaffold_cancelbutt').style.display = 'inline';
    } else {
        bev.scfd.updatebutt.style.display = 'inline';
	bev.scfd.updatebutt.style.backgroundColor = '#e0e0e0';
	document.getElementById('genomebevscfd_cancelbutt').style.display = 'inline';
    }
}
function toggle33(which) {
/* show svg output panel
which: 1 - main panel
2 - bev
3 - long-range small panel
*/
	var b1=document.getElementById('bait33_1');
	var b2=document.getElementById('bait33_2');
	var b3=document.getElementById('bait33_3');
	b1.style.display=b2.style.display=b3.style.display='none';
	if(which==1)
		b1.style.display='table';
	else
		fatalError('toggle33: unknown which');
}



/* associated with Information table */
function resize_informationTable() {
// call after stuffing things into trackdetailtable
    var table = document.getElementById('trackdetailtable');
    var d = table.parentNode;
    if(table.clientHeight > 250) {
        d.style.height = 250;
	d.style.overflowY = "scroll";
    } else {
        d.style.height = "auto";
	d.style.overflowY = "auto";
    }
}
function displayGenomeInfo() {
// called by clicking button, display info about this genome
	browser.ajax('getgenomeinfo=on&dbName='+browser.genome.name,function(data){
		document.getElementById('simpleinfowrapper').style.display='block';
		var table = document.getElementById('simpleinfotable');
		stripChild(table.firstChild, 0);
		var lst = data.info.split('|');
		var color = '#ededed';
		for(var i=0; i<lst.length; i+=2) {
			var tr = table.insertRow(-1);
			tr.style.backgroundColor = color;
			color = color=='transparent' ? '#ededed' : 'transparent';
			tr.insertCell(0).innerHTML = lst[i];
			tr.insertCell(1).innerHTML = lst[i+1];
		}
		//resize_informationTable();
	});
}


/* open manual functions and wrappers */
function openManual(what) {
    // called by clicking question mark sign
    window.open(window.location.href.split('?')[0]+"manual/#"+what);
}
function openManual_customtrack(event) {
    /* jumps to a chapter about one custom track file type
       event.target is ? button, .what is which chapter (cust track type) to go to
     */
    var what = event.target.what;
    if(what == undefined)
        what = "a"; // default is first one whatsoever
    window.open(window.location.href.split('?')[0]+"manual/#b-c-"+what);
}
function openManual_config(event) {
    /* jumps to a chapter, either config or misc functions
       event.target is ? button, .what is which chapter (cust track type) to go to
     */
    var what = event.target.what;
    if(what == undefined)
        what = "a"; // default is first one whatsoever
    window.open(window.location.href.split('?')[0]+"manual/#g-"+what);
}


function tabclick_geneset(what) {
    // what kind of geneset to submit
    document.getElementById("genesetwrapper_custom").style.display = "none";
    document.getElementById("genesettab_custom").className = "cptaboff";
    document.getElementById("genesetwrapper_kegg").style.display = "none";
    document.getElementById("genesettab_kegg").className = "cptaboff";
    document.getElementById("genesetwrapper_"+what).style.display = "block";
    document.getElementById("genesettab_"+what).className = "cptabon";
}
function tabclick_geneset2(what) {
    // available operations after submitting geneset
    document.getElementById("geneset2wrapper_addremove").style.display = "none";
    document.getElementById("geneset2tab_addremove").className = "cptaboff";
    document.getElementById("geneset2wrapper_changepart").style.display = "none";
    document.getElementById("geneset2tab_changepart").className = "cptaboff";
    document.getElementById("geneset2wrapper_sort").style.display = "none";
    document.getElementById("geneset2tab_sort").className = "cptaboff";
    //document.getElementById("geneset2wrapper_geneplot").style.display = "none";
    //document.getElementById("geneset2tab_geneplot").className = "cptaboff";
    document.getElementById("geneset2wrapper_"+what).style.display = "block";
    document.getElementById("geneset2tab_"+what).className = "cptabon";
    if(what == 'sort') {
        document.getElementById('genesetsortby0').checked = true;
	genesetsortbyChangeoption();
    }
}





/*********************************
      operations on
      positions & coordinates
 *********************************/
function leftwingAtborder() {
    // if left wing is at left border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[dspBoundary.lwr][6]==border.lname) && (regionLst[dspBoundary.lwr][3]<=border.lpos);
    } else {
        return (regionLst[dspBoundary.lwr][0]==border.lname) && (regionLst[dspBoundary.lwr][3]<=border.lpos);
    }
}
function rightwingAtborder() {
    // if right wing is at right border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[dspBoundary.rwr][6]==border.rname) && (regionLst[dspBoundary.rwr][4]>=border.rpos);
    } else {
        return (regionLst[dspBoundary.rwr][0]==border.rname) && (regionLst[dspBoundary.rwr][4]>=border.rpos);
    }
}


/*** _private_ functions ***/

function __jsonPageinit(data)
{
/* private stuff to do after json data is returned
*/

// stuff species menu
var bait3 = document.getElementById('bait3');
if(bait3){
	stripChild(bait3.firstChild, 0);
	for(var i=0; i<dblst.length; i++) {
		var v=dblst[i];
		if(v.dbname == browser.genome.name) {
			var d=document.getElementById('hook3');
			if(d) {
				d.style.color=v.fontcolor;
				d.innerHTML = v.label+'&nbsp;&nbsp;&#9662;';
			}
			d=document.getElementById('genomelogoartholder');
			if(d) d.style.backgroundImage="url('images/"+v.organism+".png')";
			continue;
		}
		var td = bait3.insertRow(-1).insertCell(0);
		td.className = 'headerTd2';
		td.style.backgroundImage = "url('images/"+v.organism+".png')";
		td.style.width='257px';
		td.style.color=v.fontcolor;
		td.innerHTML=v.label;
		td.dbname=v.dbname;
		td.addEventListener('click', changedb, false);
	}
}

//document.getElementById("greetingmsg").innerHTML = data.greeting;
if('serverload' in data) {
	var lst = data.serverload.split(' ');
	print2console(data.hostname+' load: '+lst[lst.length-3]+' '+lst[lst.length-2]+' '+lst[lst.length-1],1);
}

/*** highlight any new changes
bubble.says.innerHTML='<div style="padding:10px;padding-bottom:0px;color:white;font-size:18px;">Click here for Apps</div>';
bubble.sayajax.innerHTML='';
bubble.style.display='block';
var pos=absolutePosition(appbutt);
bubble.style.left=pos[0];
bubble.style.top=pos[1]+appbutt.clientHeight+5;
setTimeout("bubbleHide()",1300);
simulateEvent(appbutt,'mouseover');
setTimeout("simulateEvent(appbutt,'mouseout')", 300);
setTimeout("simulateEvent(appbutt,'mouseover')", 600);
setTimeout("simulateEvent(appbutt,'mouseout')", 900);
***/
/* over */
}


/*** _private_ ends ***/



function mayUpdateBorder(data) {
    if('border' in data) mustUpdateBorder(data);
}

function moveMergeNumericaldata(source, sink) {
    var oldlen = sink.length;
    var newlen = source.length;
    if(move.direction == null) {
        // replace old sink data with new data
	for(var i=0; i<newlen; i++)
	    sink[i] = source[i];
	if(oldlen > newlen) {
	    for(i=0; i<newlen-oldlen; i++)
	        sink.pop();
	}
    } else if(move.direction == 'l') {
	if(move.merge) {
	    var lastr = source[newlen-1];
	    sink[0] = lastr.concat(sink[0]);
	    source.pop();
	}
	for(var i=newlen-2; i>=0; i--)
	    sink.unshift(source[i]);
    } else {
	if(move.merge) {
	    sink[oldlen-1] = sink[oldlen-1].concat(source[0]);
	    source.shift();
	}
	for(var i=0; i<source.length; i++)
	    sink.push(source[i]);
    }
}




/*******************************
     CGI parameter composing
     these functions must return something, 
     or else "undefined" will show up in param string...
 *******************************/

function chiapetRegionParam() {
    // chrom, start, stop, spnum, joined by comma
    if(!chiapet.inuse) return '';
    var lst = [];
    for(var i=0; i<chiapet.viewlst.length; i++) {
        if(chiapet.viewlst[i]==undefined || chiapet.viewlst[i].type!=1) continue;
        var d = chiapet.datalst[i];
        lst.push(d.chrom+','+d.actualcoord[0]+','+d.actualcoord[1]+','+d.spnum);
    }
    if(lst.length==0) return '';
    return '&chiapetregion='+lst.join(',');
}
function hmtkChoice_htest() {
// categorical tracks are not involved in htest
	var alltk = [];
	for(var i=1; i<=htest.grpnum; i++) {
		alltk = alltk.concat(htest["gtn"+i]);
	}
	var ft2=[], ft3=[], ft14=[], ft15=[];
	for(var i=0; i<alltk.length; i++) {
		var obj = browser.findHmtk(alltk[i]);
		if(obj.ft==FT_bedgraph_c) {
			ft3.push(obj.url);
			ft3.push(obj.name);
		} else if(obj.ft==FT_bigwighmtk_c) {
			ft15.push(obj.url);
			ft15.push(obj.name);
		} else if(obj.ft==FT_bedgraph_n) {
			ft2.push(obj.name);
		} else if(obj.ft==FT_bigwighmtk_n) {
			ft14.push(obj.name);
		}
	}
	return (ft2.length>0 ? "&hmtk2="+ft2.join(",") : "") +
		   (ft3.length>0 ? "&hmtk3="+ft3.join(",") : "")+
		   (ft14.length>0 ? "&hmtk14="+ft14.join(",") : "")+
		   (ft15.length>0 ? "&hmtk15="+ft15.join(",") : "");
}







function customtkregistry_click(event) {
	var d=event.target;
	if(d.tagName!='TD') d=d.parentNode;
	var p=d.parentNode.nextSibling;
	p.style.display=(p.style.display=='none') ? 'table-row' : 'none';
}




/*******************************
      JSON + trigger name
 ******************************/
function jsonHmtk(data) {
/* process hmtk, native and custom, add to display list
if display object is missing, create new one
registry object must exist!

!! add one new custom track is not done here
*/
	if(data.hmtkData==undefined) return;
	for(var i=0; i<data.hmtkData.length; i++) {
		var t=data.hmtkData[i];
		var obj=browser.findHmtk(t.name);
		if(obj==null) {
			obj=createDisplayobject_hmtk(t.name);
			browser.gmlst.push(obj);
		}
		if(move.direction == null) {
			// not moving
			obj.data = t.data;
		} else if(move.direction == 'l') {
			// moving to 'l'
			var newlst = t.data;
			if(move.merge) {
				var lastr = newlst[newlst.length-1];
				obj.data[0] = lastr.concat(obj.data[0]);
				newlst.pop();
			}
			obj.data = newlst.concat(obj.data);
		} else {
			// moving to 'r'
			var newlst = t.data;
			if(move.merge) {
				obj.data[obj.data.length-1] = obj.data[obj.data.length-1].concat(newlst[0]);
				newlst.shift();
			}
			obj.data = obj.data.concat(newlst);
		}

		/* in case of restoring session, need to restore .qtc before rendering tracks
		*/
		if(data.qtc!=undefined && (obj.name in data.qtc))
			qtc_paramCopy(data.qtc.hmtk[obj.name], obj.qtc);

    	drawHmCanvas_onetrack(obj,false);
	}
}
function mergeStackData4moving(gf, newdata) {
    /* newdata is list of newly coming items from server-json
       they will be added to decorCanvasHash[gf].data,
       and items with same id will be merged in old/new holders.
       see "trigger dependency.dia" for description on item array
     */
    var od = decorCanvasHash[gf].data; // old data
    if(move.direction == 'l') {
        // moving left, need to shift plotting coord of old data by leftnewlen
        for(var i=0; i<od.length; i++) 
	    od[i][0] += leftnewlen; // box start
    } else {
        // moving right, shift new data coord by leftoldlen
        for(var i=0; i<newdata.length; i++)
	    newdata[i][0] += leftoldlen;
    }
    // with new data, merge items already exists in old
    var lk = decorCanvasHash[gf].lookup;
    for(var i=0; i<newdata.length; i++) {
        var jack = newdata[i];
        if(jack[2] in lk) {
            var jill = lk[jack[2]];
            if(move.direction == 'l') {
	        // jack placed before jill, modify box start and width
		jill[0] = jack[0];
		jill[1] += jack[1];
	    } else {
	        // jack appended to jill, only modify box width
		jill[1] += jack[1];
	    }
	} else {
	    od.push(jack);
	}
    }
}




/*** similar as decor item info system, click on metadata color block also generates tooltip
     still uses decor item tooltip
 ***/




function ajaxShowCustomtracks(tklst) {
/* for tracks that are already registered
arg: [[ft, tkname], ...]
TODO categorical
TODO store cutoff params in registry object
*/
	var p1=[], p3=[], p5=[], p10=[], p15=[];
	for(var i=0; i<tklst.length; i++) {
		switch(tklst[i][0]) {
		case FT_bed_c: p1.push(tklst[i][1]); break;
		case FT_bedgraph_c: p3.push(tklst[i][1]); break;
		case FT_sam_c: p5.push(tklst[i][1]); break;
		case FT_lr_c: p10.push(tklst[i][1]); break;
		case FT_bigwighmtk_c: p15.push(tklst[i][1]); break;
		default: fatalError('ajaxShowCustomtracks: unsupported ft');
		}
	}
	var param=[];
	if(p1.length > 0) {
		var lst=[];
		for(var i=0; i<p1.length; i++) {
			var o=decorInfo[p1[i]];
			lst.push(p1[i]+','+o.label+','+o.url+','+o.mode);
		}
		param.push('&decor1='+lst.join(','));
	}
	if(p5.length > 0) {
		var lst=[];
		for(var i=0; i<p5.length; i++) {
			var o=decorInfo[p5[i]];
			lst.push(p5[i]+','+o.label+','+o.url+','+o.mode);
		}
		param.push('&decor5='+lst.join(','));
	}
	if(p10.length > 0) {
		var lst=[];
		for(var i=0; i<p10.length; i++) {
			var o=decorInfo[p10[i]];
			lst.push(p10[i]+','+o.label+','+o.url+','+o.mode+',2,-2');
		}
		param.push('&decor10='+lst.join(','));
	}
	if(p3.length > 0) {
		var lst=[];
		for(var i=0; i<p3.length; i++)
			lst.push(hmtk[p3[i]].url+','+p3[i]);
		param.push('&hmtk3='+lst.join(','));
	}
	if(p15.length > 0) {
		var lst=[];
		for(var i=0; i<p15.length; i++)
			lst.push(hmtk[p15[i]].url+','+p15[i]);
		param.push('&hmtk15='+lst.join(','));
	}
	ajax('showcustomtk=on&'+displayedRegionParamPrecise()+chiapetRegionParam()+param.join(''),function(data){
		if(data.decorData!=undefined) {
			jsonDecor(data);
			for(var i=0; i<data.decorData.length; i++)
				decorInfo[data.decorData[i][0]].showbutt.innerHTML='hide';
		}
		if(data.hmtkData!=undefined) {
			jsonHmtk(data);
			for(var i=0; i<data.hmtkData.length; i++)
				hmtk[data.hmtkData[i].name].showbutt.innerHTML='hide';
		}
		browser.makeTrackAttrAll();
		browser.mcm_sorthmtk(sortTrackIdx);
		drawTrackAttrCanvas(browser);
		stuffTrackCanvas2holder();

		custmd_makegrid();
	});
}



/*******************************
     HMTK heatmap tracks
 ******************************/
/*** HMTK ends ***/







function makeTrackCheckboxHtml(tkname) {
    // make a checkbox for a track, with the label, return html
    return "<input type=checkbox id="+tkname+" onchange=trackcheckboxOnchange(event)> <label for="+tkname+">"+hmtk[tkname].label+"</label>";
}
function track2addCancel() {
	stripChild(document.getElementById("track2addtable"), 0);
	document.getElementById("track2addwrapper").style.display = "none";
	trackselectionCancel();
}
function trackcheckboxOnchange(event) {
	track2addAddRemoverow(event.target.id, event.target.checked);
}
function updateAfterRemovetrack(nativeRemoved) {
	updateDsp();
    trackHeightChanged(false);
	if(chiapet.inuse) {
		// uses number "i"
		for(var j=0; j<chiapet.viewlst.length; j++) {
			if(chiapet.viewlst[j]==undefined || chiapet.viewlst[j].type!=1) continue;
			// remove those that are not found in main browser object
			var lst = chiapet.datalst[j].hmtk;
			var idx=0;
			while(true) {
				if(idx>=lst.length-1) break;
				if(browser.findHmtk(lst[idx].name)==null) {
					chiapet.viewlst[j].hmdiv.removeChild(lst[idx].hmC);
					lst.splice(i,1);
				} else {
					idx++;
				}
			}
		}
	}
}
function removeHmtk_iconchange(event) {
/* tracks on display will have a cross icon in track selection panel,
clicking them will remove this track from display,
and change the cross icon into a checkbox in case user regrets what he's done
event.target is the icon, sits in an identifiable <div>
*/
	var d = event.target.parentNode;
	var td = d.parentNode; // <td>
	var tkn = d.title;
	td.innerHTML = makeTrackCheckboxHtml(tkn);
	browser.removeHmtk(tkn);
	updateAfterRemovetrack(tkn in hmtk);
}
function removeAlltracks() {
// called by pusing button, remove all hmtks
	var l = browser.gmlst.length;
	var hasnative=false;
	for(i=0; i<l; i++) {
		if(!isCustom(browser.gmlst[0].ft))
			hasnative=true;
		browser.removeHmtk(browser.gmlst[0].name);
	}
	updateAfterRemovetrack(hasnative);
}
function toggleDecor(tkname) {
/* turn on a decor by simulating change of <select>
mode has to be already set in decorInfo
<select>.selectedIndex will have no use
*/
    if(!(tkname in decorInfo))
        fatalError('turnonDecor: '+tkname+' not found in decorInfo');
    var obj = decorInfo[tkname];
    changeSelectByValue(obj.selectdom, obj.mode);
    simulateEvent(obj.selectdom,'change');
}
function ajaxAddOneServerbam(event) {
/* called by clicking button
add one bam track given its file name
TODO instead of using thin as default, allow user to choose mode
TODO chiapet
*/
    if(entire.length >= 1000000) {
        print2console('For security purpose, please zoom in to narrower region to display read alignment data', 2);
	return;
    }
    var fname = event.target.getAttribute('tkname');
    if(fname in decorInfo) {
        if(decorInfo[fname].mode == M_hide) {
	    decorInfo[fname].mode = M_den;
	    toggleDecor(fname);
	    return;
	}
        print2console('This track is already in display', 2);
	return;
    }
    ajax(displayedRegionParamPrecise()+'&addserverbam='+fname+',thin',function(data){
        if(!('serverbamdata' in data))
	    fatalError('ajaxAddOneServerbam: serverbamdata missing');
	jsonAddoneserverbam(data.serverbamdata[0]);

        unveil(viewbox);
        print2console("read alignment track added", 1);
        document.body.style.cursor = 'auto';
    });
}
function jsonAddoneserverbam(data) {
// data is an array [name, label, mode, [data] ]
// TODO should be incorporated into jsonDecor
    var name = data[0];
    var label = data[1];
    makeNewDecorCanvas(name, data[3], data[2], 4, null, 0, label);
    drawDecorCanvas(name);
    decorCanvasHash[name].canvas.style.left = move.styleLeft;
    decoruserlist_insert(name);
    // register this track
    tkselect.decor.grptab_nativebam.style.display = 'block';
    var tr = tkselect.decor.tkholder_nativebam.insertRow(-1);
    decorInfo[name].tksregistrytr = tr;
    var td = tr.insertCell(0);
    // TODO add information link for user to obtain information about this track
    td.innerHTML = label;
    td.className = 'tkentry';
    td.setAttribute('tkname', name);
    td.setAttribute('name', 'decortkentry');
    td.style.backgroundColor = 'transparent';
    td.addEventListener('click', decortkentry_click, false);
    decorInfo[name].tksentry = td;
}





/********************
   HTEST related functions
 ********************/
function pvcutoff_selectchange() {
    // the <select> in qtc panel, works for normal/bev htest
    if(qtc.which == 9) {
        // normal htest
	htest.qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
	drawHtestCanvas(false);
    } else if(qtc.which == 8) {
        // bev htest
	bev.data[bev.ongoing].qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
	bev_plot(bev.ongoing);
    } else {
        fatalError('pvcutoff_selectchange: unknown qtc.which '+qtc.which);
    }
}
function drawHtestHeadercanvas() {
    htest.header.width = leftColumnWidth;
    htest.header.height = htest.canvas.height;
    htest.header.ctx = htest.header.getContext('2d');
    var ctx = htest.header.ctx;
    ctx.fillStyle = 'black';
    ctx.font = 'bold 8pt Sans-serif';
    ctx.fillText('log10 P value', 1, 20);
    ctx.fillText('cutoff: '+getSelectValueById('pvcutoff'), 1, 36);
    drawVerticalAxis(htest.qtc,htest.header, 0, htest.minlogpv, true, 'black');
}
function drawHtestCanvas(tosvg,data) {
/* call this when pvalue is available
pvalue cutoff is always read from pvcutoff <select>
if 2nd argument is provided, it is pvalue newly generated by cgi
*/
    if(!htest.inuse) {return;}
    if(data != undefined) {
        if(move.direction == null) {
            htest.pvalue = data;
        } else if(move.direction == 'l') {
	    if(move.merge) {
		htest.pvalue[0] = data[data.length-1].concat(htest.pvalue[0]);
		data.pop();
	    }
            htest.pvalue = data.concat(htest.pvalue);
        } else {
	    if(move.merge) {
	        var lastr = htest.pvalue[htest.pvalue.length-1];
		htest.pvalue[htest.pvalue.length-1] = lastr.concat(data[0]);
		data.shift();
	    }
            htest.pvalue = htest.pvalue.concat(data);
	}
    }

    /* header will have 4 ticks: 0.0005 0.005 0.05 1
       so zero pvalue will be replaced by to 0.0005
     */
    htest.canvas.width = entire.spnum;
    htest.canvas.height = htest.qtc.height+densitydecorpaddingtop*2;
    htest.holder.style.height = htest.canvas.height;
    htest.header.height = htest.canvas.height;
    htest.canvas.style.left = move.styleLeft;
    var ctx = htest.canvas.ctx;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    var logpv = qtrack_logtransform(htest.pvalue, htest.qtc, dspBoundary.lwr,dspBoundary.rwr,dspBoundary.lws,dspBoundary.rws);
    var thv = qtrack_getthreshold(logpv, htest.qtc, dspBoundary.vstartr, dspBoundary.vstopr, dspBoundary.vstarts, dspBoundary.vstops);
    htest.minlogpv = thv[1];
    drawHtestHeadercanvas();
    var svgdata=qtrack_plotwiggle(logpv, ctx, htest.qtc, 0, thv[1], unitwidth, false, true, tosvg);

    // draw cutoff line
    var lcv = Math.log(htest.qtc.pvcutoff) * Math.LOG10E;
    var liney=null;
    if(lcv > htest.minlogpv) {
	ctx.fillStyle = htest.qtc.pvccolor;
	liney=densitydecorpaddingtop+htest.qtc.height*lcv/htest.minlogpv;
	ctx.fillRect(0,liney,htest.canvas.width,1);
    }
    if(tosvg) return [svgdata[0], thv, liney];
}
function turnoffHtest() {
    htest.holder.style.display = 'none';
    htest.header.style.display = 'none';
    htest.inuse = false;
    document.getElementById("htestsaysno").style.display = "block";
    document.getElementById("htestsaysyes").style.display = "none";
}
function htest_grpbuttOn(grpnumber) {
    document.getElementById('htestgroupdiv_'+grpnumber).firstChild.firstChild.style.display = "block";
}
function pwc_grpbuttOn(grpnumber) {
    document.getElementById('htestgroupdiv_'+grpnumber).firstChild.firstChild.style.display = "none";
}
function htest_grpbuttOff(grpnumber) {
    document.getElementById('pairwisecompgroup'+grpnumber).firstChild.firstChild.style.display = "block";
}
function pwc_grpbuttOff(grpnumber) {
    document.getElementById('pairwisecompgroup'+grpnumber).firstChild.firstChild.style.display = "none";
}
function addhmtkgroupholder(grpnumber,height,type) {
    /* make hmtk group holder for htest and pwc
       return list of two dom objects: wrapper to be inserted in place, holder to add ID
       arg is number of group
     */
    var holderid;
    if(type == 'htest') {
        holderid = 'htestgroupdiv_'+grpnumber;
    } else if(type == 'pwc') {
        holderid = 'pairwisecompgroup'+grpnumber;
    } else {
        fatalError('addhmtkgroupholder: unknown type');
    }
    var color = colorCentral.longlst[grpnumber];
    color = lightencolor(colorstr2int(color),0.4);
    var table = document.createElement("table");
    table.cellSpacing = 0;
    table.style.backgroundColor = '#fcf8ee';
    table.style.border = "solid 1px "+color;
    table.style.marginBottom = "10px";
    var tr = table.insertRow(0);
    var td = tr.insertCell(0);
    td.style.backgroundColor = color;
    td.align = 'center';
    td.innerHTML = 'GROUP '+grpnumber;
    td = tr.insertCell(-1);
    td.align='right';
    td.innerHTML = '<button class=s holderid='+holderid+' onclick=hmtkgrp_clear(event)>&#10005; clear</button> <button class=s ttype='+type+' grp='+grpnumber+' holderid='+holderid+' onmousedown=tkspanel_close() onclick=hmtkgrp_invoketksp(event)>add &#187;</button>';
    // track holder
    tr = table.insertRow(-1);
    td = tr.insertCell(0);
    td.style.width = 360;
    td.style.height= height;
    td.vAlign = "top";
    td.colSpan = 2;
    td.id = holderid;
    return table;
}
function addhtestgroup() {
// can be called by pushing add group button
	if(browser.htest.inuse) turnoffHtest();
	browser.htest.grpnum++;
	document.getElementById("htestgroupholder").appendChild(addhmtkgroupholder(browser.htest.grpnum,10,'htest'));
	document.getElementById("htestremovegrpbutton").disabled = (browser.htest.grpnum > 2) ? false : true;
}
function addpwcgroups() {
    /* just called once during page load up */
    document.getElementById("pwcgroupholder").appendChild(addhmtkgroupholder(1,10, 'pwc'));
    document.getElementById("pwcgroupholder").appendChild(addhmtkgroupholder(2,10,'pwc'));
}
function removehtestgroup() {
    if(htest.inuse) turnoffHtest();
    htest.grpnum--;
    var h = document.getElementById("htestgroupholder");
    h.removeChild(h.lastChild);
    document.getElementById("htestremovegrpbutton").disabled = (htest.grpnum > 2) ? false : true;
    // remove last option of <select> 
    for(var i=0; i<tkLst.length; i++) {
        var s = document.getElementById(tkLst[i].name+"htestgrpselect");
	s.removeChild(s.lastChild);
    }
}
function htestgroupclearcontent() {
    // called by pushing button, will clear all groups
    if(htest.inuse) turnoffHtest();
    for(var i=1; i<=htest.grpnum; i++) {
        stripChild(document.getElementById("htestgroupdiv_"+i), 0);
    }
}
function menuHtesttkassigngrp(event) {
    // called on clicking grp box on context menu
    // decide if to change single/multiple track
    if(menu.context == 1) {
        // single track
        if(menu.iY >= tkLst.length) 
	    fatalError("menuHtesttkassigngrp: wrong tkLst index");
	htest_assigngrp(tkLst[menu.iY].name, event.target.grpid);
    } else if(menu.context == 2) {
        // multiple tracks
	for(var i=0; i<menu.trackIdxLst.length; i++) {
	    if(menu.trackIdxLst[i] >= tkLst.length)
	        fatalError("menuHtesttkassigngrp: wrong tkLst index");
	    htest_assigngrp(tkLst[menu.trackIdxLst[i]].name, event.target.grpid);
	}
    }
    if(htest.inuse) turnoffHtest();
}
function menuPairwisecomptkassigngrp(grpid) {
    // similar as htest counterpart, argument is group id 1/2
    if(menu.context == 1) {
        // single track
        if(menu.iY >= tkLst.length) 
	    fatalError("menuHtesttkassigngrp: wrong tkLst index");
	pwc_assigngrp(tkLst[menu.iY].name, grpid);
    } else if(menu.context == 2) {
        // multiple tracks
	for(var i=0; i<menu.trackIdxLst.length; i++) {
	    if(menu.trackIdxLst[i] >= tkLst.length)
	        fatalError("menuHtesttkassigngrp: wrong tkLst index");
	    pwc_assigngrp(tkLst[menu.trackIdxLst[i]].name, grpid);
	}
    }
    if(pwc.inuse)
        turnoffPairwisecomp();
}
function htest_assigngrp(tkname, grp) {
    /* assign a track to a htest group
       1. track name
       2. group number, 0 means this track does not belong to any group
     */
    //if(htest.inuse) turnoffHtest();
    // remove this track from its old group, if any
    var d = document.getElementById(tkname+"inhtestgrp");
    if(d!=null && d.parentNode!=null) {
	d.parentNode.removeChild(d);
    }
    if(grp == 0) {
        if(tkselect.main.style.display=='block') {tkspanel_hmtoggle(tkname);}
	return;
    }
    // assign track to that group
    d = document.createElement("div");
    d.id = tkname+"inhtestgrp";
    d.setAttribute('tkname', tkname);
    // in case track is custom
    var tkobj = browser.findHmtk(tkname);
    d.innerHTML = "<span style=\"cursor:pointer;color:#c00;\" onclick=\"htest_assigngrp('"+tkname+"',0)\">&#10005;</span> "+(tkobj==null ? hmtk[tkname].label : tkobj.label);
    document.getElementById("htestgroupdiv_"+grp).appendChild(d);
}
function cgiHtest() {
/* called upon pushing "run test" button
or restoring session?
verify at least two htest groups are there with children
*/
	var good = 0;
	for(var i=1; i<=htest.grpnum; i++) {
		if(document.getElementById("htestgroupdiv_"+i).childNodes.length > 0)
			good++;
	}
	if(good < 2) {
		print2console("make at least 2 track groups", 2);
		turnoffHtest();
		return;
	}
	for(i=1; i<=htest.grpnum; i++) {
		htest["gtn"+i] = [];
		var lst = document.getElementById("htestgroupdiv_"+i).childNodes;
		for(var j=0; j<lst.length; j++) {
			htest["gtn"+i].push(lst[j].getAttribute('tkname'));
		}
	}
	ajaxHtest();
}
function ajaxHtest() {
	htest.holder.style.display = 'block';
	htest.header.style.display = 'block';
	htest.inuse = true; // need to set to true before calling htestParams()
	document.getElementById("htestsaysno").style.display = "none";
	document.getElementById("htestsaysyes").style.display = "block";
	cloak(viewbox);
	print2console("running hypothesis test...", 0);
	ajax(displayedRegionParamPrecise()+hmtkChoice_htest()+htestParams(), function(data) {
		drawHtestCanvas(false,data.htestData);
		unveil(viewbox);
		done();
	});
}
function addHtestgrp2menu() {
    // add group options to context menu
    var holder = document.getElementById("menuHtestgrpholder");
    stripChild(holder, 0);
    for(var i=1; i<=htest.grpnum; i++) {
        var d = document.createElement("div");
	d.grpid = i;
	d.className = "groupselector";
	d.style.display = "inline-block";
	d.style.backgroundColor = colorCentral.longlst[i];
	d.style.marginLeft = 5;
	d.innerHTML = '&nbsp;'+i+'&nbsp;';
	d.addEventListener("click", menuHtesttkassigngrp, false)
	holder.appendChild(d);
    }
}





function setDisplaywhichgf() {
    /* display brief info on top of heatmap panel
       also on collation on/off indicator
       juxtaposition.type has to be set to proper value before calling this
     */
    //var sp = document.getElementById("displaywhichgf");
    var sp2 = document.getElementById("juxtaposewhat");
    if(juxtaposition.type == 0) {
	//sp.innerHTML = juxtaposition.note;
    } else if(juxtaposition.type==1 || juxtaposition.type==2 || juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
	//sp.innerHTML = 
	sp2.innerHTML = juxtaposition.note;
    } else {
	fatalError("setDisplaywhichgf: unknown juxtaposition.type");
    }
}

function cgiJuxtapose(event) {
/* this is supposedly only called by hand-selection on radio buttons
deals with server/custom bigbed
use event.target.className to tell
*/

    var c = event.target.className;
    if(c!="server" && c!="custom")
        fatalError("cgiJuxtapose: wrong event.target.className");

    if(c == "server") {
        juxtaposition.type = 1;
	juxtaposition.note = event.target.alt;
	juxtaposition.what = event.target.value;
    } else {
        juxtaposition.type = 2;
	juxtaposition.note = "custom bigBed track";
	juxtaposition.what = event.target.value;
    }
    setDisplaywhichgf();
    juxtaposeAddBlinders();

    cloak(viewbox);
    print2console("juxtaposing "+juxtaposition.note+"...", 0);
    ajaxX(displayedRegionParam()+"&changeGF=on");
}


function cgiGetData() {
/* get data underlining genome heatmap
called by pushing button, one of those misc function
what if there's no track on?
*/
	document.getElementById("getdatawriteshere").innerHTML = "working...";
	ajax(displayedRegionParamPrecise()+hmtkChoice(browser.gmlst)+"&sptotalnum="+hmSpan+"&getdata=on",function(data){
		document.getElementById("getdatawriteshere").innerHTML = "right click on link and save: <a style='text-decoration:underline' href=t/"+sessionId+".txt target=_blank>tabular</a> <a style='text-decoration:underline' href=t/"+sessionId+".wig target=_blank>wiggle</a>";
	});
}
function cgiGetSeq() {
	// called by pushing button, one of those misc function
	var yellat = document.getElementById("getseqwriteshere");
	yellat.innerHTML = "working...";
	var v = document.getElementById("getseqcoord").value;
	if(v == "enter coordinate") {
		// fetch seq for currently displayed region
		var el = entire.atbplevel ? hmSpan/entire.bpwidth : hmSpan*entire.summarySize;
		if(el > 1000000) {
			yellat.innerHTML = "length of currently displayed region exceeds 1 mega bp, try zoom in to a shorter range";
			return;
		}
		// make region coords over dsp
		var lst = [];
		var tt = getViewRangeCoord();
		for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
			lst.push(regionLst[i][0]+':'+
				(i==dspBoundary.vstartr ? tt[0] : regionLst[i][3]) +':'+
				(i==dspBoundary.vstopr ? tt[1] : regionLst[i][4]));
		}
		v = lst.join(':');
	}
	ajax2("hmspan=1&getChromseqtemp=on&regionlst="+v+"&dbName="+dbInfo.name+'&session='+sessionId, function(data){
		document.getElementById("getseqwriteshere").innerHTML = "<a style='text-decoration:underline' href=t/"+sessionId+"."+data+".fa target=_blank>right click on link and save</a>";
		document.getElementById("getseqcoord").value = "enter coordinate";
	});
}



/**********************************
   CORRelation function has 4 layers 

   cgiCorrelation -- called by user clicking radio buttons
   jsonCorr
   computeCorr
   drawCorr
 *********************************/
function drawCorrscalecanvas() {
    // re-draw correlation scale canvas
    // usually width will change, but height won't be changed
    var c = document.getElementById('corrscalecanvas');
    c.width = leftColumnWidth;
    c.height = 27;
    var sp = 5; // spacing
    var w = leftColumnWidth - sp*2;
    ctx = c.getContext('2d');
    ctx.font = "10pt Sans-serif";
    ctx.fillStyle = "black";
    var x = 0;
    ctx.fillRect(x+sp,24,w,1); // horizontal backbone
    ctx.fillText("-1", x+1,15);
    ctx.fillRect(x+sp,19,1,5); // tick
    x = w/2+sp;
    ctx.fillText("0", x-2,15);
    ctx.fillRect(x,19,1,5); // tick
    x = sp+w;
    ctx.fillText("1", x-4,15);
    ctx.fillRect(x-1,19,1,5); // tick
}
function jsCorrelation(data) {
    /* only do stuff on client side
       argument is numerical data to compute correlation against,
       like tkLst[i].data or decorCanvasHash[gf].data
     */
    correlation.rawdata = data;
    computeCorr();
    for(var i=0; i<tkLst.length; i++)
        corrHolder.appendChild(tkLst[i].coC);
}
function hmtkRadioClickCorrelation(event) {
    /* calling correlation by clicking on radio button
       ** only for hm tracks **
     */
    var dn = event.target.value;
    var ft = parseInt(event.target.getAttribute('filetype'));
    correlation.targetft = ft;
    correlation.targetname = dn;
    correlation.where = 0;
    correlation.inuse = true;
    runCorrelation();
}

function runCorrelation() {
/* used to initiate correlation
- menu option selection
- checking radio buttons
- restore session

if decor is not displayed or not in show/density mode, run ajax and compute data!!

but not to be called when moving
*/
	if(!correlation.inuse)
		return;
	var tft = correlation.targetft;
	var tname = correlation.targetname;
	switch(tft) {
	case FT_bedgraph_c:
	case FT_bedgraph_n:
	case FT_bigwighmtk_c:
	case FT_bigwighmtk_n:
		// quantitative hmtk
		var tk = browser.findHmtk(tname);
		if(tk == null) {
			fatalError("runCorrelation: heatmap track not found");
		}
		jsCorrelation(tk.data);
		corrStageOpen(tk.label);
		return;
	case FT_qdecor_n:
		// ASSume decor bigwig can only be 8
		// just see if bigwig is displayed, no need to check mode...
		if(tname in decorCanvasHash) {
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			ajax(displayedRegionParamPrecise()+"&decor8="+tname+","+M_show, function(data){
				jsCorrelation(data["decorData"][0][4]);
			});
		}
		corrStageOpen(decorInfo[tname].label);
		return;
	case FT_bed_c:
	case FT_bed_n:
		/* decor bigbed density */
		if(tname in decorCanvasHash && decorInfo[tname].mode==M_den) {
			// this decor is been displayed in density mode
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			// not in correct mood, ajax kicks in
			var param;
			if(tft == FT_bed_n)
				param = displayedRegionParamPrecise()+"&decor0="+tname+",density";
			else
				param = displayedRegionParamPrecise()+"&decor1="+tname+","+escape(decorInfo[tname].url)+",density";
			ajax(param, function(data){
				jsCorrelation(data["decorData"][0][4]);
			});
		}
		corrStageOpen(decorInfo[tname].label);
		return;
	case FT_sam_c:
	case FT_sam_n:
		if(!(tname in decorCanvasHash)) {
			print2console("BAM track not in display", 2);
			correlation.inuse = false;
			return;
		}
		jsCorrelation(decorCanvasHash[tname].data);
		corrStageOpen(decorInfo[tname].label);
		return;
	default:
		fatalError("runCorrelation: unknown target type");
	}
}
function corrStageOpen(saywhat) {
    // set up stage and print out some words. opposite is turnoffCorrelation()
    document.getElementById('corrwhich').innerHTML = saywhat;
    document.getElementById('corrscalecanvas').style.display = 'block';
    document.getElementById('corrnotinuse').style.display = 'none';
    document.getElementById('corrinuse').style.display = 'block';
}
function jsonCorr(data) {
// argument is wholesome json object retrieved by ajax
	if(!correlation.inuse)
		return;
	var tft = correlation.targetft;
	var tname = correlation.targetname;
	if(isHmtk(tft)) {
		// hm bigwig
		var tk = browser.findHmtk(tname);
		if(tk == null) {
			print2console("jsonCorr: heatmap track not found", 2);
			correlation.inuse = false;
			return;
		}
		jsCorrelation(tk.data);
	} else if(tft == FT_qdecor_n) {
		// ASSume decor bigwig can only be 8
		if(tname in decorCanvasHash) {
			// is been displayed
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			if(!("corrData" in data))
			fatalError("jsonCorr: corrData missing");
			moveMergeNumericaldata(data["corrData"], correlation.rawdata);
			jsCorrelation(correlation.rawdata);
		}
	} else if(tft==FT_bed_c || tft==FT_bed_n) {
		// bigbed
		if(tname in decorCanvasHash && decorInfo[tname].mode==M_den) {
			// this decor is been displayed in density mode
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			if(!("corrData" in data))
			fatalError("jsonCorr: corrData missing");
			moveMergeNumericaldata(data["corrData"], correlation.rawdata);
			jsCorrelation(correlation.rawdata);
		}
	} else if(tft==FT_sam_c || tft==FT_sam_n) {
		// bam, same treatment as bigbed
		if(tname in decorCanvasHash && decorInfo[tname].mode==M_den) {
			// this decor is been displayed in density mode
			jsCorrelation(decorCanvasHash[tname].data);
		} else {
			if(!("corrData" in data))
			fatalError("jsonCorr: corrData missing");
			moveMergeNumericaldata(data["corrData"], correlation.rawdata);
			jsCorrelation(correlation.rawdata);
		}
	} else {
		fatalError("jsonCorr: unknown target type");
	}
}
function initiateCorrCanvasCtx(ctx) {
    // add color gradient for correlation coefficient plot
    var lingrad = ctx.createLinearGradient(0,0,leftColumnWidth,0);
    var tq = correlation.qtc;
    lingrad.addColorStop(0,'rgb('+tq.nr+','+tq.ng+','+tq.nb+')');
    lingrad.addColorStop(0.5,lightencolor([tq.nr,tq.ng,tq.nb],0.7));
    lingrad.addColorStop(0.5,lightencolor([tq.pr,tq.pg,tq.pb],0.7));
    lingrad.addColorStop(1,'rgb('+tq.pr+','+tq.pg+','+tq.pb+')');
    ctx.fillStyle = lingrad;
}
function viewingRegionData2array(data) {
    /* "data" is 2d array for numerical data on regions: [[v1,v2,v3,...], [], ...]
       for data between viewed regions, compress into to one array, 
       doesn't include spacing between regions

       - track score
       - decor density
       - corrData.raw
     */
    var tmp = [];
    for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	var start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts : 0;
	var stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++)
	    tmp.push(data[i][j]);
    }
    return tmp;
}
function spearmanRankCorr(v1, v2) {
    // works for arrays of any length
    var rho = 0;
    var L = v1.length;
    for(var i=0; i<L; i++)
        rho += (v1[i]-v2[i]) * (v1[i]-v2[i]);
    rho = 1 - 6*rho/(L*(L*L-1));
    return rho;
}
function computeCorr_onetrack(tk) {
    // compute correlation for one track
    var tmp = viewingRegionData2array(tk.data);
    var rk = correlation.rankeddata;
    if(tmp.length != rk.length) 
        fatalError('Track '+tk.name+' has different vector length to compute correlation: '+tmp.length+' '+rk.length);
    var tkrank = array2rank(tmp);
    tk.corr = spearmanRankCorr(tkrank, rk);
    //if(Math.abs(rho) > 1) alert(tk.label+' '+rho);
    drawCorr_onetrack(tk);
}
function computeCorr() {
    // gf density data is in corrData, might be dsp+wings
    // for each track, compute its correlation with corrData
    // store result in tk.corr
    var tmp = viewingRegionData2array(correlation.rawdata);
    correlation.rankeddata = array2rank(tmp);
    for(i=0; i<tkLst.length; i++) 
        computeCorr_onetrack(tkLst[i]);
}
function array2rank(data) {
    // fractional ranking (1, 2.5, 2.5, 4)
    var valueCount = {};
    // key: value, val: # of items having this value
    var sortdata = []; // the "keys" of valueCount...
    for(var i=0; i<data.length; i++) {
        if(data[i] in valueCount) {
	    valueCount[data[i]]++;
	} else {
	    valueCount[data[i]] = 1;
	    sortdata.push(data[i]);
	}
    }
    sortdata.sort(numSort);
    var cumulativeRank = 1;
    var value2rank = {}; // key: value, val: rank
    for(i=0; i<sortdata.length; i++) {
        if(valueCount[sortdata[i]] == 1) {
	    value2rank[sortdata[i]] = cumulativeRank++;
	} else {
	    var xx = 0;
	    for(var j=0; j<valueCount[sortdata[i]]; j++)
	        xx += cumulativeRank+j;
            value2rank[sortdata[i]] = xx/valueCount[sortdata[i]];
	    cumulativeRank += valueCount[sortdata[i]];
	}
    }
    var rank = [];
    for(i=0; i<data.length; i++)
        rank.push(value2rank[data[i]]);
    return rank;
}
function drawCorr() {
    for(var i=0; i<tkLst.length; i++) drawCorr_onetrack(tkLst[i]);
}
function drawCorr_onetrack(tk) {
    // argument is element in tkLst
    tk.coC.ctx.clearRect(0,0,leftColumnWidth,tk.hmC.height);
    var spacing = 5;
    var middle = leftColumnWidth/2;
    var w = (middle-spacing)*tk.corr;
    if(tk.corr > 0) {
	tk.coC.ctx.fillRect(middle, 0, w, tk.hmC.height);
    } else if(tk.corr < 0) {
	tk.coC.ctx.fillRect(middle+w, 0, -w, tk.hmC.height);
    }
}
function turnoffCorrelation() {
    correlation.inuse = false;
    stripChild(corrHolder, 0);
    document.getElementById('corrscalecanvas').style.display = 'none';
    document.getElementById('corrnotinuse').style.display = 'block';
    document.getElementById('corrinuse').style.display = 'none';
}
function generictrackdiv_mouseoout(event) {
    indicator.style.display = "none";
    var obj = event.target;
    while(obj.tk == undefined) {
        obj = obj.parentNode;
	if(obj == null) return;
    }
    obj.style.backgroundColor = "transparent";
}



/***********************
   DRAWing functions 
 ***********************/
function sortNumber(a,b) {
    return a-b;
}


function drawOnehmtk(obj) {
/* draw all associated canvases for one hmtk global_browser
argument is tkLst[] element
*/
    drawHmCanvas_onetrack(obj,false);
    drawTrackAttrCanvas_onetrack(obj, browser.mcm.lst, false);
    obj.coC.height = obj.hmC.height;
    obj.labeldiv.style.height = obj.hmC.height;
    initiateCorrCanvasCtx(obj.coC.ctx);
    if(correlation.inuse)
		drawCorr_onetrack(obj);
}
function qtcpanel_close() {
    // close quantitative track config panel in ftb
    if(document.getElementById("ftb_qtCfgdiv").style.display == "none") return;
    document.getElementById("ftb_qtCfgdiv").style.display = "none";
    indicator3.style.display = "none";
    indicator5.style.display = "none";
    // task type-specific cleanup
    if(qtc.which == 8) {
        // configuring bev vector
	if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    for(var vn in bev.data) {
	        if(bev.data[vn].onshow) {
	            bev.data[vn].tr.childNodes[3].style.backgroundColor = "transparent";
		}
	    }
	} else {
	    bev.data[bev.ongoing].tr.childNodes[3].style.backgroundColor = "transparent";
	}
    } else if(qtc.which==3 || qtc.which==8) {
        // toggle the wrench icon background color in user list table
        if(menu.decorname != undefined)
	    decoruserlist_togglewrench(menu.decorname);
    }
}








/*** PWC pairwise comparison ***/
function pwc_assigngrp(tkname,grp) {
/* similar as htest_assigngrp()
grp is 0/1
*/
    var d = document.getElementById(tkname+'inpwcgrp');
    if(d!=null && d.parentNode!=null) {
	d.parentNode.removeChild(d);
    }
    if(grp == 0) {
        if(tkselect.main.style.display=='block') {tkspanel_hmtoggle(tkname);}
	return;
    }
    // assign track to desired group
    d = document.createElement("div");
    d.id = tkname+"inpwcgrp";
    d.setAttribute('tkname',tkname);
    // to work with custom bigwig tracks, as their name do not exist in hmtk
    var tkobj = browser.findHmtk(tkname);
    d.innerHTML = "<span style=\"cursor:pointer;color:#c00;\" onclick=\"pwc_assigngrp('"+tkname+"',0)\">&#10005;</span> "+(tkobj!=null ? tkobj.label : hmtk[tkname].label);
    document.getElementById("pairwisecompgroup"+grp).appendChild(d);
}
function turnonPairwisecomp() {
    pwc.inuse = true;
    pwc.viewbox.style.display = "block";
    pwc.header.style.display = "block";
    document.getElementById("pairwisecompsaysno").style.display = "none";
    document.getElementById("pairwisecompsaysyes").style.display = "block";
}
function turnoffPairwisecomp() {
    pwc.inuse = false;
    pwc.viewbox.style.display = "none";
    pwc.header.style.display = "none";
    document.getElementById("pairwisecompsaysno").style.display = "block";
    document.getElementById("pairwisecompsaysyes").style.display = "none";

    if(chiapet.inuse) {
	for(i=0; i<chiapet.viewlst.length; i++) {
	    if(chiapet.viewlst[i]==undefined  || chiapet.viewlst[i].type!=1) continue;
	    chiapet.viewlst[i].pwccanvas.style.display = 'none';
	}
    }
}
function pairwisecompClear() {
    turnoffPairwisecomp();
    stripChild(pwc.grp1, 1);
    stripChild(pwc.grp2, 1);
    pwc.gtn1 = [];
    pwc.gtn2 = [];
    for(var i=0; i<tkLst.length; i++) {
        document.getElementById(tkLst[i].name+"pairwisecompgrpselect").selectedIndex = 0;
    }
}
function pwc_run() {
/* called by pushing run button
or during restoring session
will initialize .gtn1, .gtn2
and call compute routine
*/
    var lst = pwc.grp1.childNodes;
    if(lst.length == 0) {
        print2console("group 1 has no tracks", 2);
	return;
    }
    pwc.gtn1 = [];
    pwc.gtn2 = [];
    for(var i=0; i<lst.length; i++) {
        pwc.gtn1.push(lst[i].getAttribute('tkname'));
    }
    lst = pwc.grp2.childNodes;
    if(lst.length == 0) {
        print2console("group 2 has no tracks", 2);
	return;
    }
    print2console("running pairwise comparison...", 0);
    for(var i=0; i<lst.length; i++) {
        pwc.gtn2.push(lst[i].getAttribute('tkname'));
    }
    turnonPairwisecomp();
    pwc_compute();
    tkspanel_close();
}
function pwc_compute() {
/* called when pwc.gtn1/2 are ready
compute log ratio from track score, them call drawing routine

track name are converted to tkLst index each time calling,
but the index is not saved as track order could be changed
*/

    // gti: tkLst index of tracks in each group
    var gti1=[]; var gti2=[];
    for(var i=0; i<pwc.gtn1.length; i++) {
        gti1.push(getTkidxByname(pwc.gtn1[i]));
    }
    for(i=0; i<pwc.gtn2.length; i++) {
        gti2.push(getTkidxByname(pwc.gtn2[i]));
    }

    var logratio = []; // simulate array of array from first region to dspBoundary.lwr
    for(var i=0; i<=dspBoundary.rwr; i++) {
        logratio.push([]);
    }
    for(i=0; i<dspBoundary.lws; i++) {
        logratio[dspBoundary.lwr].push(0);
    }

    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
        var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++) {
	    var grp1value = [];
	    var grp2value = [];
	    for(var k=0; k<gti1.length; k++) {
	        grp1value.push(tkLst[gti1[k]].data[i][j]);
	    }
	    for(k=0; k<gti2.length; k++) {
	        grp2value.push(tkLst[gti2[k]].data[i][j]);
	    }
	    logratio[i][j] = Math.log(arrayMean(grp1value)/arrayMean(grp2value)) * Math.LOG2E;
	}
    }
    pwc.logratio = logratio;
    pwc_draw(false);
    
    if(chiapet.inuse) {
	for(i=0; i<chiapet.viewlst.length; i++) {
	    if(chiapet.viewlst[i]==undefined || chiapet.viewlst[i].type!=1) continue;
	    chiapet_pwc(i);
	}
    }
	done();
}
function pwc_draw(tosvg) {
/* set canvas height, viewbox height, draw track, draw header
cannot draw chiapet here, or will result in error
*/
    var tmp = qtrack_getthreshold(pwc.logratio, pwc.qtc, dspBoundary.vstartr, dspBoundary.vstopr, dspBoundary.vstarts, dspBoundary.vstops);
    pwc.max = tmp[0];
    pwc.min = tmp[1];

    var c = pwc.canvas;
    c.width = entire.spnum;
    c.height = pwc.qtc.height + densitydecorpaddingtop*2;
    pwc.viewbox.style.height = c.height;
    pwc.header.height = c.height;

    c.style.left = move.styleLeft;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    var svgdata=qtrack_plotwiggle(
    	pwc.logratio, c.getContext('2d'),
	pwc.qtc, pwc.max, pwc.min,
	unitwidth, false, true,
	tosvg);
    drawPairwiseHeadercanvas();

    if(tosvg) return [svgdata[0],tmp];
}
function drawPairwiseHeadercanvas() {
    pwc.header.width = leftColumnWidth;
    var ctx = pwc.header.getContext('2d');
    ctx.font = "8pt Sans-serif";
    ctx.fillText("Pairwise log ratio", 1, 20);
    ctx.fillText("log2(grp1/grp2)", 1, 30);
    drawVerticalAxis(pwc.qtc,pwc.header, pwc.max, pwc.min, true, 'black');
}




function changedb(event)
{
/* called by clicking <td> on species menu (bait3)
as many html components will be reloaded
*/
// remove previous genome, and all tentacles
delete genome[browser.genome.name];
if(browser.correlation.inuse)
	turnoffCorrelation();
if(browser.pwc.inuse)
	turnoffPairwisecomp();
browser.cleanuphtmlholder();
stripChild(browser.genome.mdselect.nativeholder,0);
// reload database
toggle3_2();
browser.loadgenome_initbrowser(event.target.dbname,{},{custom_md:true,custom_track:true});
}


/*** CONFIG
 ***/
function config_leftcolumnwidth(change) {
    var v;
    if(change == 999) {
        v = 300;
	change = v - leftColumnWidth;
    } else if(change == -999){
        v = 100;
	change = v - leftColumnWidth;
    } else {
       v = leftColumnWidth + change;
       if(v<100 || v>300)
	   return;
    }
    leftColumnWidth = v;
    document.getElementById("corrCanvasholder").style.width = v;

    var l = parseInt(mdcholder.style.left);
    mdcholder.style.left = l+change;

    for(var dn in decorCanvasHash)
        drawDecorHeadercanvas(dn);

    // corr: scale canvas, holder, corr coef canvas for each track
    drawCorrscalecanvas();
    corrHolder.style.width = leftColumnWidth;
    for(var i=0; i<tkLst.length; i++) {
        tkLst[i].coC.width = v;
	initiateCorrCanvasCtx(tkLst[i].coC.ctx);
    }
    if(correlation.inuse)
        drawCorr();

    drawHtestHeadercanvas();

    if(pwc.inuse)
        drawPairwiseHeadercanvas();

    if(ideogram.wiggle1.name != null)
	draw_ideogramWiggleHeader(1);
    if(ideogram.wiggle2.name != null)
	draw_ideogramWiggleHeader(2);

}
function config_tracklabelshow() {
    var onshow = document.getElementById("tracklabelshow").checked;
    onshow = !onshow;
    document.getElementById("tracklabelshow").checked = onshow;
    document.getElementById("tracklabelshowsaysno").style.display = onshow ? "none" : "block";
    document.getElementById("tracklabelshowsaysyes").style.display = onshow ? "block" : "none";
    tracklabelholder.style.display = onshow ? "block" : "none";
    viewbox.tknameshow = onshow;
}
function config_todefault() {
    leftColumnWidth = 110;
    config_leftcolumnwidth(0);
}








/*** config decor ***/
function stcpanel_hide() {
    document.getElementById("ftb_stcdiv").style.display = "none";
    indicator3.style.display = "none";
    indicator5.style.display = "none";
    decoruserlist_togglewrench(document.getElementById("ftb_stcdiv").target);
}
function stc_precaution() {
// in case the decor track got removed when the stc panel is still on
    var decorname = document.getElementById('ftb_stcdiv').target;
    if(decorname==undefined || !(decorname in decorCanvasHash)) {
        stcpanel_hide();
	print2console("track has been removed", 2);
	return null;
    }
    return decorname;
}
function stc_longrange_pcolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    document.getElementById("ftb_stcdiv").target = dn;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 7;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_longrange_pcolor2(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    decorCanvasHash[decorname].pcolor = palette.output;
    document.getElementById(decorname+7).style.backgroundColor = palette.output;
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function stc_longrange_ncolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    document.getElementById("ftb_stcdiv").target = dn;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 9;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_longrange_ncolor2(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    decorCanvasHash[decorname].ncolor = palette.output;
    document.getElementById(decorname+9).style.backgroundColor = palette.output;
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}


function stc_textcolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 36;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function stc_textcolor2() {
    var decorname = stc_precaution(); if(decorname == null) return;
    decorCanvasHash[decorname].textcolor = palette.output;
    document.getElementById(decorname+36).style.backgroundColor = palette.output;
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function stc_bedcolor2_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 35;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function stc_bedcolor2(event) {
	var decorname = stc_precaution(); if(decorname == null) return;
	decorCanvasHash[decorname].bedcolor = palette.output;
	document.getElementById(decorname+35).style.backgroundColor = palette.output;
	drawDecorCanvas(decorname);
	if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function stc_beddensitycolor_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 37;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function stc_beddensitycolor(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    document.getElementById(decorname+37).style.backgroundColor = palette.output;
    var c = colorstr2int(palette.output);
    decorCanvasHash[decorname].qtc.pr=c[0];
    decorCanvasHash[decorname].qtc.pg=c[1];
    decorCanvasHash[decorname].qtc.pb=c[2];
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function decor8_pcolor_initiator(event) {
// short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 38;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function decor8_pcolor(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    document.getElementById(decorname+38).style.backgroundColor = palette.output;
    var c = colorstr2int(palette.output);
    decorCanvasHash[decorname].qtc.pr=c[0];
    decorCanvasHash[decorname].qtc.pg=c[1];
    decorCanvasHash[decorname].qtc.pb=c[2];
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function decor8_ncolor_initiator(event) {
    // short cut icons in user list table
    var dn = event.target.parentNode.parentNode.getAttribute('tkname');
    if(decorInfo[dn].mode==undefined || decorInfo[dn].mode==M_hide) {
        print2console('cannot apply config option: this track is not displayed yet',2);
	return;
    }
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.style.backgroundColor);
    palette.which = 39;
    document.body.addEventListener("mousedown", palettehide, false);
    document.getElementById("ftb_stcdiv").target = dn;
}
function decor8_ncolor(event) {
    var decorname = stc_precaution(); if(decorname == null) return;
    document.getElementById(decorname+39).style.backgroundColor = palette.output;
    var c = colorstr2int(palette.output);
    decorCanvasHash[decorname].qtc.nr=c[0];
    decorCanvasHash[decorname].qtc.ng=c[1];
    decorCanvasHash[decorname].qtc.nb=c[2];
    drawDecorCanvas(decorname);
    if(chiapet.inuse) chiapet_draw1decor_allviews(decorname);
}
function chiapetvp_pcolor_initiator(event) {
// chiapetvp chr henge plot positive color
    var vidx = parseInt(event.target.viewidx);
    if(chiapet.viewlst[vidx].type!=2) return;
    document.getElementById("ftb_stcdiv").target = vidx;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.color);
    palette.which = 10;
    document.body.addEventListener("mousedown", palettehide, false);
}
function chiapetvp_pcolor() {
    var vidx = document.getElementById("ftb_stcdiv").target;
    chiapet.datalst[vidx].decor.pcolor = colorstr2int(palette.output).join(',');
    chiapetvp_chrhenge(vidx);
}
function chiapetvp_ncolor_initiator(event) {
// chiapetvp chr henge plot negative color
    var vidx = parseInt(event.target.viewidx);
    if(chiapet.viewlst[vidx].type!=2) return;
    document.getElementById("ftb_stcdiv").target = vidx;
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(event.target.color);
    palette.which = 11;
    document.body.addEventListener("mousedown", palettehide, false);
}
function chiapetvp_ncolor() {
    var vidx = document.getElementById("ftb_stcdiv").target;
    chiapet.datalst[vidx].decor.ncolor = colorstr2int(palette.output).join(',');
    chiapetvp_chrhenge(vidx);
}




// htest cutoff line color
function htest_clc_initiator(event) { // htest cutoff line color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('htest_clc').style.backgroundColor);
    palette.which = 34;
    document.body.addEventListener("mousedown", palettehide, false);
}
function htest_clc() {
    var c = palette.output;
    document.getElementById('htest_clc').style.backgroundColor = c;
    if(qtc.which == 9) {
	htest.qtc.pvccolor = c;
	drawHtestCanvas(false);
    } else if(qtc.which == 8) {
	bev.data[bev.ongoing].qtc.pvccolor = c;
	bev_plot(bev.ongoing);
    } else {fatalError('htest_clc: unknown qtc.which');}
}






function done() {print2console('done', 1);}

function print2console(what, msgtype)
{
switch(msgtype) {
case 0:
	// normal
	msgconsole.innerHTML+='<br>'+what;
	break;
case 1:
	// done
	msgconsole.innerHTML+='<div style="font-size:12px;color:#2A9242;">'+what+'</div>';
	break;
case 2:
	// reminder or warning
	msgconsole.innerHTML+='<div style="font-size:12px;color:#E4273A;">'+what+'</div>';
	shake_dom(floatingtoolbox);
	break;
case 3:
	// fatal error
	msgconsole.innerHTML+='<div style="font-size:12px;color:white;background-color:#E3394A;">'+what+'</div>';
	shake_dom(floatingtoolbox);
	break;
default: return;
}
msgconsole.scrollTop = 9999; // dummy
}
function msgconsoleMD(event) { // clumsy
	event.preventDefault();
	msgconsole.x = event.clientX;
	msgconsole.y = event.clientY;
	document.body.addEventListener('mousemove', msgconsoleM, false);
	document.body.addEventListener('mouseup', msgconsoleMU, false);
}
function msgconsoleM(event) {
	var a = parseInt(msgconsole.style.width);
	if(event.clientX < msgconsole.x) {
		if(a + event.clientX - msgconsole.x < 244) {
			msgconsole.style.width = 244;
			return;
		}
	}
	msgconsole.style.width = a + event.clientX - msgconsole.x;
	msgconsole.x = event.clientX;
	a = parseInt(msgconsole.style.height);
	if(event.clientY < msgconsole.y) {
		if(a + event.clientY - msgconsole.y < 20) {
			msgconsole.style.height = 20;
			return;
		}
	}
	msgconsole.style.height = a + event.clientY - msgconsole.y;
	msgconsole.y = event.clientY;
}
function msgconsoleMU(event) {
    document.body.removeEventListener('mousemove', msgconsoleM, false);
    document.body.removeEventListener('mouseup', msgconsoleMU, false);
}
function fatalError(brick) { print2console(brick, 3); throw(brick); }





/* __sticky__ note */
function menu_stickynote() {
// called by selecting sticknote option from app list
	menu_shutup();
	menu.stickynote.style.display='block';
}

function makestickynote() {
// return dom object of the note for further handling
	var note = document.createElement("div");
	document.body.appendChild(note);
	var ta = document.createElement("textarea");
	ta.readOnly = true;
	ta.cols = 15;
	ta.rows = 3;
	note.appendChild(ta);
	note.className = "stickynote";
	note.style.left = Math.random()*800;
	note.style.top = Math.random()*600;
	stickynote.number++;
	note.id = stickynote.number+"stickynote";
	note.addEventListener("mousedown", stickynoteMD, false);
	note.addEventListener("mouseover", stickynoteMOV, false);
	note.addEventListener("mouseout", stickynoteMOT, false);
	// edit and delete buttons
	var but = document.createElement("div");
	note.appendChild(but);
	but.innerHTML = "<span style='cursor:pointer;' onclick=stickynote_edit(event)>&#9998;</span> <span style='cursor:pointer;' onclick=stickynote_remove(event)>&#10006;</span>";
	// "done with edit" button
	but = document.createElement("div");
	note.appendChild(but);
	but.innerHTML = "<span style='cursor:pointer;' onclick=stickynote_doneedit(event)>&#10004;</span>";
	return note;
}
function stickynote_remove(event) {
// delete a note
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	document.body.removeChild(note);
}
function stickynote_edit(event) {
// open textarea and edit, hide pencil button and disable moving
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	note.childNodes[1].style.display = "none"; // hide pencil buttons
	note.childNodes[2].style.display = "block"; // show "done edit" button
	var ta = note.firstChild;
	ta.readOnly = false;
	ta.style.backgroundColor = "#F0E8B7";
	ta.focus();
	note.removeEventListener("mousedown", stickynoteMD, false);
	note.removeEventListener("mouseover", stickynoteMOV, false);
	note.removeEventListener("mouseout", stickynoteMOT, false);
}
function stickynote_doneedit(event) {
// done with textarea editing
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	var ta = note.firstChild;
	ta.readOnly = true;
	ta.style.backgroundColor = "transparent";
	note.childNodes[1].style.display = "block"; // show pencil buttons
	note.childNodes[2].style.display = "none"; // hide "done edit" button
	note.addEventListener("mousedown", stickynoteMD, false);
	note.addEventListener("mouseover", stickynoteMOV, false);
	note.addEventListener("mouseout", stickynoteMOT, false);
}
function stickynoteMOV(event) {
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	note.childNodes[1].style.display = "block";
}
function stickynoteMOT(event) {
// on mouse out
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	note.childNodes[1].style.display = "none";
}
function stickynoteMD(event) {
	event.preventDefault();
	var note = event.target;
	while(note.className != "stickynote")
		note = note.parentNode;
	stickynote.onfocus = note;
	document.body.addEventListener("mousemove", stickynoteM, false);
	document.body.addEventListener("mouseup", stickynoteMU, false);
	note.oldX = event.clientX;
	note.oldY = event.clientY;
}
function stickynoteM(event) {
	var n = stickynote.onfocus;
	n.style.left = parseInt(n.style.left) + event.clientX - n.oldX;
	n.style.top = parseInt(n.style.top) + event.clientY - n.oldY;
	n.oldX = event.clientX;
	n.oldY = event.clientY;
}
function stickynoteMU(event) {
	document.body.removeEventListener("mousemove", stickynoteM, false);
	document.body.removeEventListener("mouseup", stickynoteMU, false);
}
/* __sticky__ note ends */











function oneshot(event)
{
/* called by clicking a logo to select a genome from oneshot panel
genome dbname is given by .title
*/
var d=event.target;
while(!d.dbname) d=d.parentNode;
apps.oneshot.main.style.display='none';
pagecloak.style.display = 'none';
if(event.target.fastload)
	browser.loadgenome_initbrowser(d.dbname,{nohmtk:true},{custom_md:true,custom_track:true});
else
	browser.loadgenome_initbrowser(d.dbname,{},{custom_md:true,custom_track:true});
setTimeout("floatingtoolbox.style.display='block'",500);
}
function oneshot_mover(event)
{
var d=event.target;
while(d.className!='oneshot') d=d.parentNode;
d.childNodes[2].style.display='block';
}
function oneshot_mout(event)
{
var d=event.target;
while(d.className!='oneshot') d=d.parentNode;
d.childNodes[2].style.display='none';
}

function oneshotDialog(which,msg)
{
/* this is one shot, 
fires up the oneshot dialog when the browser needs user to make some choice to start properly
args: which
  1: show list of genome
  2: show saved status under a session
msg: an additional message to be printed on oneshot panel, warning or further instruction
*/
cloakPage();
apps.oneshot.main.style.display='block';
apps.oneshot.main.style.left = 100;
apps.oneshot.main.style.top = 70;
var d2=apps.oneshot.message;
if(msg == null) {
	d2.style.display = 'none';
} else {
	d2.style.display = 'block';
	d2.innerHTML = msg;
}
floatingtoolbox.style.display='none';
var header=apps.oneshot.header;
switch(which) {
case 1: // show list of genome ask user to choose one
	header.innerHTML='Select a genome';
	var holder=apps.oneshot.belly;
	holder.style.backgroundColor='';
	stripChild(holder, 0);
	var organism2td={}; // for putting minor genomes following their major guys
	for(var i=0; i<dblst.length; i++) {
		// the .title is used to provide dbname when clicked
		var v=dblst[i];
		if(v.ismajor!=1) continue;
		var d = document.createElement('div');
		d.dbname=v.dbname;
		d.className = 'oneshot';
		d.addEventListener('click', oneshot, false);
		d.addEventListener('mouseover',oneshot_mover,false);
		d.addEventListener('mouseout',oneshot_mout,false);
		var img=document.createElement('img');
		img.src='images/'+v.organism+'.png';
		d.appendChild(img);
		var d3 = document.createElement('div');
		d3.innerHTML=v.label;
		d.appendChild(d3);
		var tr=holder.insertRow(-1);
		tr.insertCell(0).appendChild(d);
		organism2td[v.organism]=tr.insertCell(1);
		var d4=document.createElement('div');
		d.appendChild(d4);
		d4.innerHTML='Quick';
		d4.title='Do not load default experimental assay tracks';
		d4.fastload=true; // for event
	}
	for(i=0; i<dblst.length; i++) {
		var v=dblst[i];
		if(v.ismajor!=1) {
			var d=document.createElement('div');
			d.className='header_gr';
			d.innerHTML=v.dbname;
			d.dbname=v.dbname;
			d.addEventListener('click',oneshot,false);
			organism2td[v.organism].appendChild(d);
		}
	}
	return;
case 2: // list status under a session
	header.innerHTML = 'Click <span class=header_g>name</span> to restore past browsing status';
	var d=apps.oneshot;
	d.main.style.left = (document.body.clientWidth-d.clientWidth)/2;
	d.main.style.top = (document.body.clientHeight-d.clientHeight)/2;
	d.belly.style.backgroundColor='rgba(255,255,255,0.7)';
	return;
default: fatalError('oneshotDialog: unknown which');
}
/*over*/
}



function makeUrl()
{
/* sukn only for the moment
TODO: FT_sam_n, FT_cat_c

custom md term in mcm not supported
dataset not supported
*/

var urlarr=[window.location.protocol+'//'+window.location.host+window.location.pathname+'?genome='+browser.genome.name];
var hmtk=[], gftk=[], custombed=[], custombedgraph=[], custombigwig=[], customlongrange=[], customsam=[], custombam=[];
for(var i=0; i<browser.tklst.length; i++) {
	/* custom tk label might contain space
	but escape() to %20 cannot be decoded..
	must be converted to +
	*/
	var t=browser.tklst[i];
	var m=('mode' in t) ? mode2str[t.mode] : '';
	var label=t.label.replace(/\s/g, '+'); // space must be converted to +
	switch(t.ft) {
	case FT_bed_n:
		gftk.push(t.name+','+m);break;
	case FT_bed_c:
		custombed.push(label+','+t.url+','+m);break;
	case FT_bedgraph_n:
		hmtk.push(t.name);break;
	case FT_bedgraph_c:
		custombedgraph.push(label+','+t.url);break;
	case FT_sam_c:
		customsam.push(label+','+t.url+','+m);break;
	case FT_bam_c:
		custombam.push(label+','+t.url+','+m);break;
	case FT_lr_n:
		gftk.push(t.name+','+mode2str[t.mode]);break;
	case FT_lr_c:
		customlongrange.push(label+','+t.url+','+m);break;
	case FT_cat_n:
		hmtk.push(t.name);break;
	case FT_bigwighmtk_n:
		// some numeric decor (gc5base) is now bigwig and assumes this ft!!
		if(t.name in browser.genome.decorInfo) {
			gftk.push(t.name+',show');break;
		}
		hmtk.push(t.name);break;
	case FT_bigwighmtk_c:
		custombigwig.push(label+','+t.url);break;
	};
	// don't die on unknown ft
}
if(hmtk.length>0) urlarr.push('&hmtk='+hmtk.join(','));
if(gftk.length>0) urlarr.push('&gftk='+gftk.join(','));
if(custombed.length>0) urlarr.push('&custombed='+custombed.join(','));
if(custombedgraph.length>0) urlarr.push('&custombedgraph='+custombedgraph.join(','));
if(custombigwig.length>0) urlarr.push('&custombigwig='+custombigwig.join(','));
if(customsam.length>0) urlarr.push('&customsam='+customsam.join(','));
if(custombam.length>0) urlarr.push('&custombam='+custombam.join(','));
if(customlongrange.length>0) urlarr.push('&customlongrange='+customlongrange.join(','));

if(browser.mcm.lst.length>0) {
	// only use native terms...
	var lst=[];
	for(var i=0; i<browser.mcm.lst.length; i++) {
		var s=browser.mcm.lst[i];
		if(!s[1]) lst.push(s[0]);
	}
	if(lst.length>0)
		urlarr.push('&metadata='+lst.join(','));
}

var jt=browser.juxtaposition.type;
if(jt==RM_gsv_c || jt==RM_gsv_kegg) {
	var lst=[];
	for(var i=0; i<browser.genesetview.lst.length; i++)
		lst.push(browser.genesetview.lst[i].name);
	urlarr.push('&geneset='+lst.join(','));
} else {
	var tmp=browser.getDspStat();
	if(tmp[0]==tmp[2]) {
		urlarr.push('&coordinate='+tmp[0]+':'+tmp[1]+'-'+tmp[3]);
	} else {
		urlarr.push('&coordinate2='+tmp.join(','));
	}
	if(jt==RM_jux_n) {
		urlarr.push('&juxtapose='+browser.juxtaposition.what);
	} else if(jt==RM_jux_c) {
		urlarr.push('&juxtaposecustom=on&juxtapose='+browser.juxtaposition.what);
	}
}

var spt=[];
for(var tag in browser.splinters) {
	var c=browser.splinters[tag].splinterCoord;
	spt.push(c[0]+':'+c[1]+'-'+c[2]);
}
if(spt.length>0)
	urlarr.push('&splitview='+spt.join(','));

var d=apps.session.url_holder;
d.style.display='block';
var u=urlarr.join('');
d.innerHTML='<p style="color:#858585">Share this URL ('+u.length+' characters) so that others can see the same content as you\'re seeing now</p>'+
'<a href="'+u+'" target=_blank>'+u+'</a>';
}

function sukn_initializeGenome(obj)
{
// sukn specific
obj.newcustmd_setattrvalue();
// called when urlparam, load default db, change db
var m=obj.mdselect;
m.custpriortable3=document.getElementById('custpriortable3');
m.custpriortable1=document.getElementById('custpriortable1');
m.custpriortable10=document.getElementById('custpriortable10');
m.custpriortable5=document.getElementById('custpriortable5');
m.custpriortable15=document.getElementById('custpriortable15');
/*
obj.tkselect={
	main:document.getElementById('tkspanel'),
	smallmenu:document.getElementById('tkspanelSmallmenu'),
	hmdiv:document.getElementById('hmtksp_div'),
	hmholder:document.getElementById('hmtksp_holder'),
	decor:{
		main:document.getElementById('decorsp_div'),
		grpholder:document.getElementById('decorgrp_holder'),
		tkholder:document.getElementById('decortk_holder'),
	},
};
*/
obj.scaffold.cpholder = document.getElementById('scaffold_cpholder');
obj.scaffold.spanel = document.getElementById('scfspanel');
obj.scaffold.updatebutt = document.getElementById('scaffold_updatebutt');
}



function hmtkgrp_clear(event)
{
/* clear a heatmap track group holder
   called by pushing button associated with a group holder
   event.target should be a button
   works for htest and pwc, and to be expanded
   attribute 'holderid' gives id of holder
 */
stripChild(document.getElementById(event.target.getAttribute('holderid')),0);
}

function tkspanel_hmtoggle(tkname)
{
// toggle highlight for a hmtk todo use hook
var lst = tkselect.hmholder.firstChild.childNodes;
for(var i=0; i<lst.length; i++) {
	if(lst[i].getAttribute('tkname') == tkname) {
		if(lst[i].firstChild.style.backgroundColor=='transparent') {
			lst[i].firstChild.style.backgroundColor = '#CCCCFF';
		} else {
			lst[i].firstChild.style.backgroundColor = 'transparent';
		}
		return;
	}
}
}

function hmtkgrp_invoketksp(event) {
/* called by pushing button, only works for htest and pwc
invoke tkselectpanel for pwc/htest track group assignment
check the button attributes to tell which grp holder to place the track
TODO
*/
	var bbj=gflag.browser;
	if(bbj.tklst.length == 0) {
		print2console('no track in display', 2);
		return;
	}
	var type = event.target.getAttribute('ttype');
	var which;
	if(type == 'pwc') {
		which=14;
	} else if(type == 'htest') {
		which=15;
	} else {
		fatalError('hmtkgrp_invoketksp: unknown ttype '+type);
	}
	menu_shutup();
	menu_show(which, event.clientX, event.clientY);
	gflag.menu.bbj=bbj;
	//gflag.menu.togrp:parseInt(event.target.getAttribute('grp')),
	gflag.menu.toholder=document.getElementById(event.target.getAttribute('holderid'));
	bbj.showcurrenttrack4select();
}





function urlparam_handleTriggers()
{
/* handle track-related triggers in recursive fashion
because loading datahub cannot be done with other processes
but won't call readygo again, so need to print errors to console

when doing ajax calls to process triggers,
must return and exit current function so to let ajax work
need to delete trigger from urlparam.hash before or during the call
because the ajax will call this function again to process remaining trigger,
lazy and recursive, but simple

only call once, separated from calling routine to reduce indent
*/
if('datahub' in gflag.urlparam.hash) {
	// try to load up the hub
	browser.genome.custtk.ui_hub.input_url.value = gflag.urlparam.hash.datahub;
	delete gflag.urlparam.hash.datahub;
	apps.custtk.bbj=browser; // patch, so that loaddatahub() can run
	loaddatahub();
	return;
}
if('datahubtext' in gflag.urlparam.hash) {
	// url-encoded datahub text
	var text=gflag.urlparam.hash.datahubtext;
	delete gflag.urlparam.hash.datahubtext;
	apps.custtk.bbj=browser; // patch, so that loaddatahub() can run
	loaddatahub(text);
	return;
}

/* each type of tracks are specified with given parameters
fetch all tracks with a single ajax query

notice:
native longrange tracks are still supplied from "gftk", but they are registered in genome.hmtk

notice:
before parsing native assay tracks, dataset must be loaded, or else the track won't be recognized

TODO custom categorical tracks, native sam
*/
var _tklst=[];
var nativehmtkparam='';

if('hmtk' in gflag.urlparam.hash) {
	// native bedgraph/bigwig/categorical
	// all must be found in genome.hmtk as corresponding datasets should have been loaded
	var lst = gflag.urlparam.hash.hmtk.split(',');
	for(var i=0; i<lst.length; i++) {
		var o=browser.genome.hmtk[lst[i]];
		if(o!=undefined)
			_tklst.push({name:lst[i],ft:o.ft,mode:M_show});
	}
	delete gflag.urlparam.hash.hmtk;
}

// as cgi won't keep label for custom hmtk (not sent by hmtkChoice()), need to keep in global variable


if('custombedgraph' in gflag.urlparam.hash) {
	// custom bedgraph: label, url
	var lst = gflag.urlparam.hash.custombedgraph.split(',');
	var sthwrong = false;
	var param = [];
	for(var i=0; i<lst.length; i+=2) {
		if(lst[i].length==0 || lst[i+1]==undefined || lst[i+1].length==0) {
			sthwrong=true;
			break;
		}
		if(!browser.genome.tkurlInUse(lst[i+1])) {
			_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],ft:FT_bedgraph_c,mode:M_show});
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid "custombedgraph" parameter value '+urlparamhelp, 2);
	delete gflag.urlparam.hash.custombedgraph;
}
if('custombigwig' in gflag.urlparam.hash) {
	// custom bigwig: label, url
	var lst = gflag.urlparam.hash.custombigwig.split(',');
	var sthwrong = false;
	var param = [];
	for(var i=0; i<lst.length; i+=2) {
		if(lst[i].length==0 || lst[i+1]==undefined || lst[i+1].length==0) {
			sthwrong=true;
			break;
		}
		if(!browser.genome.tkurlInUse(lst[i+1])) {
			_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],ft:FT_bigwighmtk_c,mode:M_show});
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid "custombigwig" parameter value '+urlparamhelp, 2);
	delete gflag.urlparam.hash.custombigwig;
}
if('gftk' in gflag.urlparam.hash) {
	/* native bed/qdecor/longrange: name, mode
	notice: longrange has been deemed as assay track and registered in genome.hmtk
	but native longrange are still supplied from "gftk"
	TODO native sam?
	*/
	var lst = gflag.urlparam.hash.gftk.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=2) {
		var o=browser.genome.decorInfo[lst[i]];
		if(o==undefined) o=browser.genome.hmtk[lst[i]];
		if(o==undefined) {
			print2console('unknown native decor track name "'+lst[i]+'"',2);
			continue;
		}
		if(lst[i].length>0 && lst[i+1]!=undefined && browser.findTrack(lst[i])==null) {
			if(o.ft== FT_bed_n) {
				var m = decormodestr2num(lst[i+1]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den)) m=M_den;
				_tklst.push({name:lst[i],ft:o.ft,mode:m});
			} else if(o.ft==FT_qdecor_n || o.ft==FT_bigwighmtk_n) {
				_tklst.push({name:lst[i],ft:o.ft,mode:M_show});
			} else if(o.ft== FT_lr_n) {
				var m = decormodestr2num(lst[i+1]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den && m!=M_arc && m!=M_trihm)) m=M_den;
				var style=browser.genome.trackDefaultparam[lst[i]];
				_tklst.push({name:lst[i],ft:o.ft,mode:m,
					qtc:{pfilterscore:(style==undefined?2:style.pfilterscore),
						nfilterscore:(style==undefined?-2:style.nfilterscore)}});
			} else if(o.ft==FT_cat_n) {
				_tklst.push({name:lst[i],ft:o.ft,mode:M_show});
			} else {
				fatalError('urlparam_handleTriggers: ft error with gftk param');
			}
		} else { 
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "gftk" parameter '+urlparamhelp, 2);
	delete gflag.urlparam.hash.gftk;
}
if(browser.juxtaposition.type == RM_jux_n) {
	// juxtaposing with native bed track, bring it up if it isn't there yet
	// the track should be valid, already dealt with in dsp making
	var dn = browser.juxtaposition.what;
	if(browser.findTrack(dn)==null) {
		// this is because this track might have been added in previous iteration
		var found=false;
		for(var i=0; i<_tklst.length; i++) {
			if(_tklst[i].name==dn) {
				found=true; break;
			}
		}
		if(!found) {
			_tklst.push({name:dn, ft:browser.genome.decorInfo[dn].ft, mode:M_full});
		}
	}
}
if('custombed' in gflag.urlparam.hash) {
	// custom bed, not including longrange: label, url, mode
	var sthwrong = false;
	var lst = gflag.urlparam.hash.custombed.split(',');
	for(var i=0; i<lst.length; i+=3) {
		if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined && lst[i+2].length>0) {
			if(!browser.genome.tkurlInUse(lst[i+1])) {
				var m = decormodestr2num(lst[i+2]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den)) m=M_den;
				_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],mode:m,ft:FT_bed_c});
			}
		} else {
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "custombed" parameter '+urlparamhelp, 2);
	delete gflag.urlparam.hash.custombed;
}
if('customlongrange' in gflag.urlparam.hash) {
	// custom longrange: label, url, mode
	var lst = gflag.urlparam.hash.customlongrange.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=3) {
		if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined) {
			if(!browser.genome.tkurlInUse(lst[i+1])) {
				var m = decormodestr2num(lst[i+2]);
				if(m==undefined || (m!=M_thin && m!=M_full && m!=M_den && m!=M_arc && m!=M_trihm)) m=M_den;
				var v1 = parseFloat(document.getElementById('stc_longrange_pfilterscore').value);
				if(v1<0) v1=0-v1;
				var v2 = parseFloat(document.getElementById('stc_longrange_nfilterscore').value);
				if(v2>0) v2=0-v2;
				_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],mode:m,
					ft:FT_lr_c, qtc:{pfilterscore:v1,nfilterscore:v2}});
			}
		} else {
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "customlongrange" parameter '+urlparamhelp, 2);
	delete gflag.urlparam.hash.customlongrange;
}
/* juxtaposing custom bed, add it if it's missing
*/
if(browser.juxtaposition.type == RM_jux_c) {
	var url = browser.juxtaposition.what;
	if(!browser.genome.tkurlInUse(url)) {
		var notthere=true;
		for(var i=0; i<_tklst.length; i++) {
			if(isCustom(_tklst[i].ft)) {
				if(_tklst[i].url==url) {
					notthere=false; break;
				}
			}
		}
		if(notthere) {
			_tklst.push({name:browser.genome.newcustomtrackname(),
				ft:FT_bed_c,label:'Juxtaposition',url:url,mode:M_full});
		}
	}
}

/* TODO native bam
if('bam' in gflag.urlparam.hash) { // native bam files
if(gflag.urlparam.hash.bam.length == 0) {
	print2console('URL parameter error: "bam" parameter got 0 length value', 2);
} else {
	var lst = gflag.urlparam.hash.bam.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=2) {
		if(lst[i].length>0 && lst[i+1]!=undefined && decormodestr2num(lst[i+1])!=undefined) {
		decor4lst.push(lst[i]); decor4lst.push(decormodestr2num(lst[i+1]));
	} else {sthwrong=true;}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "bam" parameter', 2);
}
delete gflag.urlparam.hash.bam;
}
*/
if('custombam' in gflag.urlparam.hash) {
	// custom sam: label, url, mode
	var lst = gflag.urlparam.hash.custombam.split(',');
	var sthwrong = false;
	for(var i=0; i<lst.length; i+=3) {
		if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined && lst[i+2].length>0) {
			if(!browser.genome.tkurlInUse(lst[i+1])) {
				var m = decormodestr2num(lst[i+2]);
				if(m == undefined || (m!=M_thin && m!=M_full && m!=M_den)) m=M_den;
				_tklst.push({name:browser.genome.newcustomtrackname(),label:unescape(lst[i]),url:lst[i+1],mode:m,ft:FT_bam_c});
			}
		} else {
			sthwrong=true;
		}
	}
	if(sthwrong)
		print2console('URL parameter error: invalid value for "custombam" parameter', 2);
	delete gflag.urlparam.hash.custombam;
}

// ajax
if(_tklst.length > 0) {
	print2console('loading tracks...',0);
	browser.ajax(browser.displayedRegionParamPrecise()+'&addtracks=on'+trackParam(_tklst)+'&dbName='+browser.genome.name,function(data){
		apps.custtk.bbj=browser;
		var custtknames=[]; // for flipping their showbutt later
		if('decorData' in data) {
			for(var i=0; i<data.decorData.length; i++) {
				var dt = data.decorData[i];
				if(isCustom(dt.ft)) {
					dt.md=[];
					dt.custmd={};
					registerCustomtrack(dt);
					custtknames.push(dt.name);
				}
			}
		}
		if('hmtkData' in data) {
			for(var i=0; i<data.hmtkData.length; i++) {
				var t=data.hmtkData[i];
				if(isCustom(t.ft)) {
					registerCustomtrack({
						name:t.name, 
						ft:t.ft,
						url:t.url,
						label:t.label,
						md:[],
						custmd:{}});
					custtknames.push(t.name);
				}
			}
		}
		browser.jsonTrackdata(data);

		for(var i=0; i<custtknames.length; i++)
			browser.genome.hmtk[custtknames[i]].showbutt.innerHTML='hide';

		/* just in case, just in case..
		when native and custom track are mixed together */


		// don't do cfacet, no custom term
		browser.mcm_sort();
		browser.prepareMcm();
		browser.trackHeightChanged();
		urlparam_handleTriggers(); // go on
	});
	return;
}

/** do not handle no track case
no matter whether urlparam has track or not
it will always reach here by recursion
**/
browser.initiateMdcOnshowCanvas();
browser.render_browser(false);
browser.generateTrackselectionLayout();


if('splitview' in gflag.urlparam.hash) {
	browser.splinterFromcoordlst(gflag.urlparam.hash.splitview.split(','));
	delete gflag.urlparam.hash.splitview;
}

done();
gflag.urlparam.willcontinue = false;
/*over*/
}


function longrange_shortcut()
{
var gn=browser.genome.name;
if(gn!='hg19' && gn!='mm9' && gn!='dm3') {
	print2console('This genome currently does not contain public long-range interaction data sets.',2);
	return;
}
apps.hmtk.bbj=browser;
if(apps.hmtk.main.style.display=='none') {
	toggle1();
}
simulateEvent(browser.facet.tab_facet,'click');
gflag.menu.termname='Long Range Interaction';
gflag.menu.currentaspect='vertical';
facet_subtable('0');
}




function __tklst() {
	var lst=[];
	for(var i=0; i<browser.tklst.length; i++) lst.push(browser.tklst[i].name);
	return lst.join(',');
}



function go2blog() {window.open('http://washugb.blogspot.com/');}


// READY
function readygo()
{
/* no argument, will be called only once upon loading browser for first time

handles url parameter
if there's no proper url parameter, will pop up oneshot dialog for choosing genome
*/
var d=document.getElementById('washucuddle');
d.innerHTML=washUtag;
d.addEventListener('click',go2blog,false);

document.body.addEventListener('keyup',page_keyup,false);

page_makeDoms(page_config);

browser=new Browser();
gflag.browser=browser;

apps.session.show_id.innerHTML=browser.sessionId;

var mholder=document.getElementById('sukn_main');
mholder.parentNode.style.backgroundColor=colorCentral.pagebg;

/* decide hmSpan
the  is a guess of default width of mdcholder.holder,
will be determined by # terms shown on default
 */
browser.leftColumnWidth=110;
browser.init_hmSpan();
browser.browser_makeDoms({
	centralholder:mholder,
	header:{
		padding:'0px 0px 10px 0px',
		fontsize:'normal',
		zoomout:[['&#8531;',0.3],[1,1],[5,5]],
		dspstat:{allowupdate:true},
		resolution:true,
		utils:{nativetk:true,customtk:true,apps:true,bbjconfig:true},
		},
	navigator:true,
	navigator_ruler:true,
	hmdivbg:'white',
	ghm_scale:true,
	ghm_ruler:true,
	tkheader:true,
	mcm:true,
	gsselect:true,
	// gsv
	gsv:true,
	gsv_geneplot:true,
	// hmtk facet
	nativefacet:true,
	tab_facet:true,
	tab_dataset:true,
	body_class:'tabpageBody',
	});
// sukn-specific tweaks
browser.hmdiv.style.backgroundColor='white';
browser.ideogram.canvas.oncontextmenu=menu_coordnote;
browser.mcm.holder.attop = true; // tells if holder be placed on top or bottom of mcm

browser.applyHmspan2holders();

/*
addhtestgroup();
addhtestgroup();
var bp=browser.pwc;
bp.canvas = document.getElementById('pwccanvas');
bp.canvas.height = bp.qtc.height + densitydecorpaddingtop*2;
bp.viewbox = document.getElementById('pwcviewbox');
bp.viewbox.style.height = bp.canvas.height;
bp.header = document.getElementById("pairwisecompHeaderCanvas");
bp.header.height = bp.canvas.height;
addpwcgroups();
bp.grp1 = document.getElementById("pairwisecompgroup1");
bp.grp2 = document.getElementById("pairwisecompgroup2");
*/

/* following are stuff belonging to "page", shared by all browser instances */



appbutt=document.getElementById('appbutt');

scalebarbeam=document.getElementById('scalebarbeam');
scalebarMout();



//drawCorrscalecanvas();

floatingtoolbox = document.getElementById("floatingtoolbox");
msgconsole = document.getElementById("msgconsole");
floatingtoolbox.style.left=browser.leftColumnWidth+browser.hmSpan-300;

simulateEvent(document.getElementById('geneplotrender'),'change');



// load dblst first
browser.ajax('load_dblst=on',function(data){
	if(!data.dblst) fatalError('failed to load dblst');
	dblst=data.dblst;


	if(window.location.href.indexOf('?') == '-1') {
		/******
		no url parameter, show list of db
		*/
		oneshotDialog(1,null);
		return;
	}
	/***
	processing url parameter
	*/
	var garbledUrl=false;
	var lst = window.location.href.split('?')[1].split('&');
	var pmhash = {};
	for(var i=0; i<lst.length; i++) {
		var t = lst[i].split('=');
		if(t.length==2 && t[0].length>0 && t[1].length>0) {
			pmhash[t[0].toLowerCase()] = t[1];
		} else {
			garbledUrl=true;
		}
	}
	if(garbledUrl) {
		oneshotDialog(1,'Garbled URL parameter '+urlparamhelp);
		return;
	}
	if(!('genome' in pmhash)) {
		oneshotDialog(1,'URL parameter error: missing essential parameter "genome" '+urlparamhelp);
		return;
	}
	var invalid_genome=true;
	for(var i=0; i<dblst.length; i++) {
		if(dblst[i].dbname==pmhash.genome) {
			invalid_genome=false;break;
		}
	}
	if(invalid_genome) {
		oneshotDialog(1, 'URL parameter error: invalid value for "genome" parameter '+urlparamhelp);
		return;
	}
	browser.genome=new Genome({custom_md:true,custom_track:true});
	browser.genome.name=pmhash.genome;
	sukn_initializeGenome(browser.genome);

	gflag.urlparam.hash = pmhash;

	/* native tracks
	*/
	var nativetk={};
	if('hmtk' in gflag.urlparam.hash) {
		var lst=gflag.urlparam.hash.hmtk.split(',');
		for(var i=0; i<lst.length; i++)
			nativetk[lst[i]]=1;
	}
	if('gftk' in gflag.urlparam.hash) {
		var lst=gflag.urlparam.hash.gftk.split(',');
		for(var i=0; i<lst.length; i+=2)
			nativetk[lst[i]]=1;
	}
	var tklst=[];
	for(var tk in nativetk) tklst.push(tk);

	/* load genome content
	will pass nativetk so to identify and load data set
	*/
	browser.ajax('first=on&loadgenome=on&quit_sukn=on&dbname='+browser.genome.name+(tklst.length>0?'&hmtk4dataset='+tklst.join(','):''), function(data){
		/* correct dbname, make genome object */
		browser.genome.jsonGenome(data);
		genome[browser.genome.name]=browser.genome;
		browser.migratedatafromgenome();
		__jsonPageinit(data);

		/*** fillup browser contents by url parameter ***/

		if('session' in gflag.urlparam.hash) {
			/*** trigger - session ***
			session content overrides everything else
			*/
			gflag.urlparam.willcontinue=false;
			browser.sessionId=gflag.urlparam.hash.session;
			// need to this so cleanuphtmlholder won't break
			browser.runmode_set2default();
			if('statusid' in gflag.urlparam.hash) {
				// statusid is provided
				browser.statusId=parseInt(gflag.urlparam.hash.statusid);
				browser.ajax('validateurlparam_sessionstatus=on&dbName='+browser.genome.name,function(data) {
					if(data.error) {
						oneshotDialog(1, 'URL parameter error: session not found '+urlparamhelp);
						return;
					}
					// session/status is valid
					browser.restoreStatus(browser.statusId);
				});
			} else {
				browser.ajax('validateurlparam_session=on&dbName='+browser.genome.name,function(data) {
					if(data.statusLst==undefined) {
						oneshotDialog(1, 'URL parameter error: session not found '+urlparamhelp);
						return;
					}
					// session is valid
					print2console('valid session id', 1);
					var holder=apps.oneshot.belly;
					stripChild(holder, 0);
					for(var i=1; i<data.statusLst.length; i++) {
						var v=data.statusLst[i];
						addRow4newStatus(holder,v[0],v[1],v[2], v[3], v[4], false);
					}
					oneshotDialog(2, null);
				});
			}
			return;
		}

		/*** no session ***/
		gflag.urlparam.willcontinue=true;
		// add metadata
		if('metadata' in gflag.urlparam.hash) {
			// native terms only
			var lst = gflag.urlparam.hash.metadata.split(',');
			var toadd = [];
			for(var i=0; i<lst.length; i++) {
				if(lst[i].length==0) continue;
				var v=unescape(lst[i]);
				if(v in browser.genome.mdvp2c) {
					// non-leaf term
					toadd.push(v);
				} else {
					// potential leaf term
					if(v in browser.genome.mdvidx2attr) toadd.push(v);
				}
			}
			browser.mdcFromNativeTerms(toadd);
			delete gflag.urlparam.hash.metadata;
		}
		/* X axis contents can be determined in following ways 
		* genome or juxtaposition
		  - coordinate param is optional, if missing, will use default position
		* gene set view
		*/
		if('geneset' in gflag.urlparam.hash) {
			var s = gflag.urlparam.hash.geneset;
			if(s.length==0 || s.indexOf(',')==-1) {
				print2console('URL parameter error: "geneset" parameter got invalid value', 2);
				// won't quit but will go on to process remaining params
			} else {
				gflag.gsv.bbj=browser; // must do this
				// must update state before calling routine
				var j=browser.juxtaposition;
				j.type=RM_gsv_c;
				j.what=j.note='custom gene set';

				browser.genesetview.submit_textarea.value = s.split(',').join('\n');
				browser.submitGeneset_custom();
				// must quit here due to ajax
				return;
			}
		} else {
			// coordinate/coordinate2, combined with juxtapostion
			var lst=browser.genome.defaultStuff.coord.split(',');
			var startchr=lst[0];
			var stopchr=lst[2];
			var startcoord=parseInt(lst[1]);
			var stopcoord=parseInt(lst[3]);
			if('coordinate' in gflag.urlparam.hash) {
				var s = gflag.urlparam.hash.coordinate;
				var pos = [null, NaN, NaN];
				if(s.length == 0) {
					print2console('URL parameter error: "coordinate" parameter got 0 length value '+urlparamhelp, 2);
				} else {
					// parse user provided coord string, must be in form of chr1:300-400
					if(s.indexOf(':') == -1) {
						print2console('URL parameter error: irregular "coordinate" parameter value '+urlparamhelp, 2);
					} else {
						var t1 = s.split(':');
						if(t1[0].length==0 || !(t1[0] in browser.genome.scaffold.len)) {
							print2console('URL parameter error: irregular "coordinate" parameter value '+urlparamhelp, 2);
						} else {
							pos[0] = t1[0];
							if(t1[1].indexOf('-') == -1) {
								print2console('URL parameter error: irregular "coordinate" parameter value '+urlparamhelp, 2);
							} else {
								var t2 = t1[1].split('-');
								pos[1] = parseInt(t2[0]);
								pos[2] = parseInt(t2[1]);
							}
						}
					}
				}
				if(pos[0]!=null && !isNaN(pos[1]) && !isNaN(pos[2])) {
					startchr = stopchr = pos[0];
					startcoord = pos[1];
					stopcoord = pos[2];
				} else {
					print2console('URL parameter error: irregular "coordinate" parameter value '+urlparamhelp, 2);
				}
				delete gflag.urlparam.hash.coordinate;
			} else if('coordinate2' in gflag.urlparam.hash) {
				var tmp=gflag.urlparam.hash.coordinate2.split(',');
				if(tmp.length!=4) {
					print2console('URL parameter error: irregular "coordinate2" parameter value '+urlparamhelp, 2);
				} else {
					var a=parseInt(tmp[1]), b=parseInt(tmp[3]);
					if(!(tmp[0] in browser.genome.scaffold.len) || !(tmp[2] in browser.genome.scaffold.len) || isNaN(a) || isNaN(b)) {

						print2console('URL parameter error: irregular "coordinate2" parameter value '+urlparamhelp, 2);
					} else {
						startchr=tmp[0];
						stopchr=tmp[2];
						startcoord=a;
						stopcoord=b;
					}
				}
				delete gflag.urlparam.hash.coordinate2;
			}
			var param = 'changeGF=on&dbName='+browser.genome.name+'&startChr='+startchr+'&startCoord='+startcoord+'&stopChr='+stopchr+'&stopCoord='+stopcoord;
			browser.runmode_set2default();

			if('juxtapose' in gflag.urlparam.hash) {
				var bbf = gflag.urlparam.hash.juxtapose;
				if(bbf.length == 0) {
					print2console('URL parameter error: "juxtapose" parameter got 0 length value', 2);
					param += '&runmode='+browser.genome.defaultStuff.runmode;
				} else {
					if('juxtaposecustom' in gflag.urlparam.hash) {
						// custom bed
						browser.juxtaposition.type = RM_jux_c;
						browser.juxtaposition.note = "custom bed track";
						browser.juxtaposition.what = bbf;
						param += '&runmode='+RM_jux_c+'&juxtaposeTk='+bbf;
					} else {
						var tk=browser.genome.decorInfo[bbf];
						if(tk!=undefined && tk.ft==FT_bed_n) {
							// native bed
							browser.juxtaposition.type = RM_jux_n;
							browser.juxtaposition.note = tk.label;
							browser.juxtaposition.what = bbf;
							param += '&runmode='+RM_jux_n+'&juxtaposeTk='+bbf;
						} else {
							print2console('URL parameter error: invalid native annotation track name provided for "juxtapose" '+urlparamhelp, 2);
							param += '&runmode='+browser.genome.defaultStuff.runmode;
						}
					}
				}
			} else {
				param+='&runmode='+browser.genome.defaultStuff.runmode;
			}
			print2console("adjusting range of display ...", 0);
			// duplicative with ajaxX
			browser.ajax(param, function(data){
				if('newscaffold' in data) {
					browser.genome.addnewscaffold([data.newscaffold[0]]);
				}
				browser.jsonDsp(data);
				urlparam_handleTriggers();
			});
			return; // must quit here
		}
		return;
	});
});
}
