#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glob.h>
#include "tabix.h"

struct beditem
{
	struct beditem *next;
	char *chrom;
	int start;
	int stop;
};




int main(int argc, char *argv[])
{



tabix_t *fin=ti_open(infile, 0);
if(fin==0) 
{
    fputs("fail to open data file\n", stderr);
    return 1;
}

if(fin->fnidx) printf("okay\n");

if(ti_lazy_index_load(fin)<0)
{
    fputs("failed to load index file\n", stderr);
    return 1;
}

int chridx, begin, end;
if(ti_parse_region(fin->idx, query, &chridx, &begin, &end)<0)
{
    fputs("invalid query coord\n", stderr);
    return 1;
}

ti_iter_t iter=ti_queryi(fin, chridx, begin, end);


struct beditem *sl=NULL, *bi;
const char *row;
char delim[]="\t";
char *tmpstr, *tok, *rest;
int len;
while((row=ti_read(fin, iter, &len)) != 0)
    {
    tmpstr=strdup(row);

	/** following deals with sam reads
	**/
	char *id=strtok(tmpstr, delim);
	char *flag=strtok(NULL, delim);

	printf("%s\t%s --|-- %s\n", id, flag, row);


	/** following deals with regular bed item
    bi=malloc(sizeof(struct beditem));
    // chr
    if((rest=strchr(tmpstr, '\t'))==NULL) die();
    tok=strtok(tmpstr, delim);
    tmpstr=++rest;
    // start
    if((rest=strchr(tmpstr, '\t'))==NULL) die();
    tok=strtok(tmpstr, delim);
    bi->start=strtod(tok,NULL);
    tmpstr=++rest;
    // stop
    if((rest=strchr(tmpstr, '\t'))==NULL) die();
    tok=strtok(tmpstr, delim);
    bi->stop=strtod(tok, NULL);
    bi->rest=strdup(++rest);

    bi->next=sl;
    sl=bi;
	*/
    }



/*

int i;

struct beditem *sl2;


puts("compStart:");
i=0;
sl2=slSortStart(sl);
for(bi=sl2; bi!=NULL; bi=bi->next)
	printf("%d  %d\t%d\t'%s'\n", i++,bi->start, bi->stop, bi->rest);


puts("\ncompStop:");
i=0;
sl2=slSortStop(sl2);
for(bi=sl2; bi!=NULL; bi=bi->next)
	printf("%d  %d\t%d\t'%s'\n", i++, bi->start, bi->stop, bi->rest);


*/



printf("all through: %s\n", fin->fn);


ti_iter_destroy(iter);
ti_close(fin);

return 1;

}
